/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 79 "cfg.y"


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "cfg_pp.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "pt_scaling.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"
#include "mem/rpm_mem.h"
#include "poll_types.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#undef MIN
#undef MAX

extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static void* cmd_tmp;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *elem;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

struct listen_param {
	enum si_flags flags;
	int workers;
	struct socket_id *socket;
	char *tag;
	char *auto_scaling_profile;
} p_tmp;
static void fill_socket_id(struct listen_param *param, struct socket_id *s);

union route_name_var {
	int iname;
	struct _pv_spec *sname;
	struct _pv_elem *ename;
	void *data;
} rn_tmp;

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)

extern int cfg_parse_only_routes;
#define IFOR(_instr) \
	if (cfg_parse_only_routes==1) {_instr;break;}


#line 222 "cfg.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cfg.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_DROP = 3,                       /* DROP  */
  YYSYMBOL_ASSERT = 4,                     /* ASSERT  */
  YYSYMBOL_EXIT = 5,                       /* EXIT  */
  YYSYMBOL_RETURN = 6,                     /* RETURN  */
  YYSYMBOL_LOG_TOK = 7,                    /* LOG_TOK  */
  YYSYMBOL_ERROR = 8,                      /* ERROR  */
  YYSYMBOL_ROUTE = 9,                      /* ROUTE  */
  YYSYMBOL_ROUTE_FAILURE = 10,             /* ROUTE_FAILURE  */
  YYSYMBOL_ROUTE_ONREPLY = 11,             /* ROUTE_ONREPLY  */
  YYSYMBOL_ROUTE_BRANCH = 12,              /* ROUTE_BRANCH  */
  YYSYMBOL_ROUTE_ERROR = 13,               /* ROUTE_ERROR  */
  YYSYMBOL_ROUTE_LOCAL = 14,               /* ROUTE_LOCAL  */
  YYSYMBOL_ROUTE_STARTUP = 15,             /* ROUTE_STARTUP  */
  YYSYMBOL_ROUTE_TIMER = 16,               /* ROUTE_TIMER  */
  YYSYMBOL_ROUTE_EVENT = 17,               /* ROUTE_EVENT  */
  YYSYMBOL_IF = 18,                        /* IF  */
  YYSYMBOL_ELSE = 19,                      /* ELSE  */
  YYSYMBOL_SWITCH = 20,                    /* SWITCH  */
  YYSYMBOL_CASE = 21,                      /* CASE  */
  YYSYMBOL_DEFAULT = 22,                   /* DEFAULT  */
  YYSYMBOL_BREAK = 23,                     /* BREAK  */
  YYSYMBOL_WHILE = 24,                     /* WHILE  */
  YYSYMBOL_FOR = 25,                       /* FOR  */
  YYSYMBOL_IN = 26,                        /* IN  */
  YYSYMBOL_NULLV = 27,                     /* NULLV  */
  YYSYMBOL_XDBG = 28,                      /* XDBG  */
  YYSYMBOL_XLOG = 29,                      /* XLOG  */
  YYSYMBOL_XLOG_BUF_SIZE = 30,             /* XLOG_BUF_SIZE  */
  YYSYMBOL_XLOG_FORCE_COLOR = 31,          /* XLOG_FORCE_COLOR  */
  YYSYMBOL_XLOG_PRINT_LEVEL = 32,          /* XLOG_PRINT_LEVEL  */
  YYSYMBOL_XLOG_LEVEL = 33,                /* XLOG_LEVEL  */
  YYSYMBOL_PV_PRINT_BUF_SIZE = 34,         /* PV_PRINT_BUF_SIZE  */
  YYSYMBOL_DEBUG_MODE = 35,                /* DEBUG_MODE  */
  YYSYMBOL_ENABLE_ASSERTS = 36,            /* ENABLE_ASSERTS  */
  YYSYMBOL_ABORT_ON_ASSERT = 37,           /* ABORT_ON_ASSERT  */
  YYSYMBOL_LOGLEVEL = 38,                  /* LOGLEVEL  */
  YYSYMBOL_LOGSTDOUT = 39,                 /* LOGSTDOUT  */
  YYSYMBOL_LOGSTDERROR = 40,               /* LOGSTDERROR  */
  YYSYMBOL_LOGFACILITY = 41,               /* LOGFACILITY  */
  YYSYMBOL_LOGNAME = 42,                   /* LOGNAME  */
  YYSYMBOL_AVP_ALIASES = 43,               /* AVP_ALIASES  */
  YYSYMBOL_LISTEN = 44,                    /* LISTEN  */
  YYSYMBOL_SOCKET = 45,                    /* SOCKET  */
  YYSYMBOL_MEMGROUP = 46,                  /* MEMGROUP  */
  YYSYMBOL_ALIAS = 47,                     /* ALIAS  */
  YYSYMBOL_AUTO_ALIASES = 48,              /* AUTO_ALIASES  */
  YYSYMBOL_TAG = 49,                       /* TAG  */
  YYSYMBOL_DNS = 50,                       /* DNS  */
  YYSYMBOL_REV_DNS = 51,                   /* REV_DNS  */
  YYSYMBOL_DNS_TRY_IPV6 = 52,              /* DNS_TRY_IPV6  */
  YYSYMBOL_DNS_TRY_NAPTR = 53,             /* DNS_TRY_NAPTR  */
  YYSYMBOL_DNS_RETR_TIME = 54,             /* DNS_RETR_TIME  */
  YYSYMBOL_DNS_RETR_NO = 55,               /* DNS_RETR_NO  */
  YYSYMBOL_DNS_SERVERS_NO = 56,            /* DNS_SERVERS_NO  */
  YYSYMBOL_DNS_USE_SEARCH = 57,            /* DNS_USE_SEARCH  */
  YYSYMBOL_MAX_WHILE_LOOPS = 58,           /* MAX_WHILE_LOOPS  */
  YYSYMBOL_UDP_WORKERS = 59,               /* UDP_WORKERS  */
  YYSYMBOL_CHECK_VIA = 60,                 /* CHECK_VIA  */
  YYSYMBOL_SHM_HASH_SPLIT_PERCENTAGE = 61, /* SHM_HASH_SPLIT_PERCENTAGE  */
  YYSYMBOL_SHM_SECONDARY_HASH_SIZE = 62,   /* SHM_SECONDARY_HASH_SIZE  */
  YYSYMBOL_MEM_WARMING_ENABLED = 63,       /* MEM_WARMING_ENABLED  */
  YYSYMBOL_MEM_WARMING_PATTERN_FILE = 64,  /* MEM_WARMING_PATTERN_FILE  */
  YYSYMBOL_MEM_WARMING_PERCENTAGE = 65,    /* MEM_WARMING_PERCENTAGE  */
  YYSYMBOL_RPM_MEM_FILE = 66,              /* RPM_MEM_FILE  */
  YYSYMBOL_RPM_MEM_SIZE = 67,              /* RPM_MEM_SIZE  */
  YYSYMBOL_MEMLOG = 68,                    /* MEMLOG  */
  YYSYMBOL_MEMDUMP = 69,                   /* MEMDUMP  */
  YYSYMBOL_EXECMSGTHRESHOLD = 70,          /* EXECMSGTHRESHOLD  */
  YYSYMBOL_EXECDNSTHRESHOLD = 71,          /* EXECDNSTHRESHOLD  */
  YYSYMBOL_TCPTHRESHOLD = 72,              /* TCPTHRESHOLD  */
  YYSYMBOL_EVENT_SHM_THRESHOLD = 73,       /* EVENT_SHM_THRESHOLD  */
  YYSYMBOL_EVENT_PKG_THRESHOLD = 74,       /* EVENT_PKG_THRESHOLD  */
  YYSYMBOL_QUERYBUFFERSIZE = 75,           /* QUERYBUFFERSIZE  */
  YYSYMBOL_QUERYFLUSHTIME = 76,            /* QUERYFLUSHTIME  */
  YYSYMBOL_SIP_WARNING = 77,               /* SIP_WARNING  */
  YYSYMBOL_SERVER_SIGNATURE = 78,          /* SERVER_SIGNATURE  */
  YYSYMBOL_SERVER_HEADER = 79,             /* SERVER_HEADER  */
  YYSYMBOL_USER_AGENT_HEADER = 80,         /* USER_AGENT_HEADER  */
  YYSYMBOL_LOADMODULE = 81,                /* LOADMODULE  */
  YYSYMBOL_MPATH = 82,                     /* MPATH  */
  YYSYMBOL_MODPARAM = 83,                  /* MODPARAM  */
  YYSYMBOL_MAXBUFFER = 84,                 /* MAXBUFFER  */
  YYSYMBOL_CHROOT = 85,                    /* CHROOT  */
  YYSYMBOL_WDIR = 86,                      /* WDIR  */
  YYSYMBOL_MHOMED = 87,                    /* MHOMED  */
  YYSYMBOL_POLL_METHOD = 88,               /* POLL_METHOD  */
  YYSYMBOL_TCP_ACCEPT_ALIASES = 89,        /* TCP_ACCEPT_ALIASES  */
  YYSYMBOL_TCP_WORKERS = 90,               /* TCP_WORKERS  */
  YYSYMBOL_TCP_CONNECT_TIMEOUT = 91,       /* TCP_CONNECT_TIMEOUT  */
  YYSYMBOL_TCP_CON_LIFETIME = 92,          /* TCP_CON_LIFETIME  */
  YYSYMBOL_TCP_LISTEN_BACKLOG = 93,        /* TCP_LISTEN_BACKLOG  */
  YYSYMBOL_TCP_SOCKET_BACKLOG = 94,        /* TCP_SOCKET_BACKLOG  */
  YYSYMBOL_TCP_MAX_CONNECTIONS = 95,       /* TCP_MAX_CONNECTIONS  */
  YYSYMBOL_TCP_NO_NEW_CONN_BFLAG = 96,     /* TCP_NO_NEW_CONN_BFLAG  */
  YYSYMBOL_TCP_NO_NEW_CONN_RPLFLAG = 97,   /* TCP_NO_NEW_CONN_RPLFLAG  */
  YYSYMBOL_TCP_KEEPALIVE = 98,             /* TCP_KEEPALIVE  */
  YYSYMBOL_TCP_KEEPCOUNT = 99,             /* TCP_KEEPCOUNT  */
  YYSYMBOL_TCP_KEEPIDLE = 100,             /* TCP_KEEPIDLE  */
  YYSYMBOL_TCP_KEEPINTERVAL = 101,         /* TCP_KEEPINTERVAL  */
  YYSYMBOL_TCP_MAX_MSG_TIME = 102,         /* TCP_MAX_MSG_TIME  */
  YYSYMBOL_ADVERTISED_ADDRESS = 103,       /* ADVERTISED_ADDRESS  */
  YYSYMBOL_ADVERTISED_PORT = 104,          /* ADVERTISED_PORT  */
  YYSYMBOL_DISABLE_CORE = 105,             /* DISABLE_CORE  */
  YYSYMBOL_OPEN_FD_LIMIT = 106,            /* OPEN_FD_LIMIT  */
  YYSYMBOL_MCAST_LOOPBACK = 107,           /* MCAST_LOOPBACK  */
  YYSYMBOL_MCAST_TTL = 108,                /* MCAST_TTL  */
  YYSYMBOL_TOS = 109,                      /* TOS  */
  YYSYMBOL_DISABLE_DNS_FAILOVER = 110,     /* DISABLE_DNS_FAILOVER  */
  YYSYMBOL_DISABLE_DNS_BLACKLIST = 111,    /* DISABLE_DNS_BLACKLIST  */
  YYSYMBOL_DST_BLACKLIST = 112,            /* DST_BLACKLIST  */
  YYSYMBOL_DISABLE_STATELESS_FWD = 113,    /* DISABLE_STATELESS_FWD  */
  YYSYMBOL_DB_VERSION_TABLE = 114,         /* DB_VERSION_TABLE  */
  YYSYMBOL_DB_DEFAULT_URL = 115,           /* DB_DEFAULT_URL  */
  YYSYMBOL_DB_MAX_ASYNC_CONNECTIONS = 116, /* DB_MAX_ASYNC_CONNECTIONS  */
  YYSYMBOL_DISABLE_503_TRANSLATION = 117,  /* DISABLE_503_TRANSLATION  */
  YYSYMBOL_SYNC_TOKEN = 118,               /* SYNC_TOKEN  */
  YYSYMBOL_ASYNC_TOKEN = 119,              /* ASYNC_TOKEN  */
  YYSYMBOL_LAUNCH_TOKEN = 120,             /* LAUNCH_TOKEN  */
  YYSYMBOL_AUTO_SCALING_PROFILE = 121,     /* AUTO_SCALING_PROFILE  */
  YYSYMBOL_AUTO_SCALING_CYCLE = 122,       /* AUTO_SCALING_CYCLE  */
  YYSYMBOL_TIMER_WORKERS = 123,            /* TIMER_WORKERS  */
  YYSYMBOL_EQUAL = 124,                    /* EQUAL  */
  YYSYMBOL_EQUAL_T = 125,                  /* EQUAL_T  */
  YYSYMBOL_GT = 126,                       /* GT  */
  YYSYMBOL_LT = 127,                       /* LT  */
  YYSYMBOL_GTE = 128,                      /* GTE  */
  YYSYMBOL_LTE = 129,                      /* LTE  */
  YYSYMBOL_DIFF = 130,                     /* DIFF  */
  YYSYMBOL_MATCH = 131,                    /* MATCH  */
  YYSYMBOL_NOTMATCH = 132,                 /* NOTMATCH  */
  YYSYMBOL_COLONEQ = 133,                  /* COLONEQ  */
  YYSYMBOL_PLUSEQ = 134,                   /* PLUSEQ  */
  YYSYMBOL_MINUSEQ = 135,                  /* MINUSEQ  */
  YYSYMBOL_SLASHEQ = 136,                  /* SLASHEQ  */
  YYSYMBOL_MULTEQ = 137,                   /* MULTEQ  */
  YYSYMBOL_MODULOEQ = 138,                 /* MODULOEQ  */
  YYSYMBOL_BANDEQ = 139,                   /* BANDEQ  */
  YYSYMBOL_BOREQ = 140,                    /* BOREQ  */
  YYSYMBOL_BXOREQ = 141,                   /* BXOREQ  */
  YYSYMBOL_OR = 142,                       /* OR  */
  YYSYMBOL_AND = 143,                      /* AND  */
  YYSYMBOL_BOR = 144,                      /* BOR  */
  YYSYMBOL_BAND = 145,                     /* BAND  */
  YYSYMBOL_BXOR = 146,                     /* BXOR  */
  YYSYMBOL_BLSHIFT = 147,                  /* BLSHIFT  */
  YYSYMBOL_BRSHIFT = 148,                  /* BRSHIFT  */
  YYSYMBOL_PLUS = 149,                     /* PLUS  */
  YYSYMBOL_MINUS = 150,                    /* MINUS  */
  YYSYMBOL_MULT = 151,                     /* MULT  */
  YYSYMBOL_MODULO = 152,                   /* MODULO  */
  YYSYMBOL_NOT = 153,                      /* NOT  */
  YYSYMBOL_BNOT = 154,                     /* BNOT  */
  YYSYMBOL_NUMBER = 155,                   /* NUMBER  */
  YYSYMBOL_ZERO = 156,                     /* ZERO  */
  YYSYMBOL_ID = 157,                       /* ID  */
  YYSYMBOL_STRING = 158,                   /* STRING  */
  YYSYMBOL_SCRIPTVAR = 159,                /* SCRIPTVAR  */
  YYSYMBOL_IPV6ADDR = 160,                 /* IPV6ADDR  */
  YYSYMBOL_IPV4ADDR = 161,                 /* IPV4ADDR  */
  YYSYMBOL_IPNET = 162,                    /* IPNET  */
  YYSYMBOL_COMMA = 163,                    /* COMMA  */
  YYSYMBOL_SEMICOLON = 164,                /* SEMICOLON  */
  YYSYMBOL_RPAREN = 165,                   /* RPAREN  */
  YYSYMBOL_LPAREN = 166,                   /* LPAREN  */
  YYSYMBOL_LBRACE = 167,                   /* LBRACE  */
  YYSYMBOL_RBRACE = 168,                   /* RBRACE  */
  YYSYMBOL_LBRACK = 169,                   /* LBRACK  */
  YYSYMBOL_RBRACK = 170,                   /* RBRACK  */
  YYSYMBOL_SLASH = 171,                    /* SLASH  */
  YYSYMBOL_AS = 172,                       /* AS  */
  YYSYMBOL_USE_WORKERS = 173,              /* USE_WORKERS  */
  YYSYMBOL_USE_AUTO_SCALING_PROFILE = 174, /* USE_AUTO_SCALING_PROFILE  */
  YYSYMBOL_MAX = 175,                      /* MAX  */
  YYSYMBOL_MIN = 176,                      /* MIN  */
  YYSYMBOL_DOT = 177,                      /* DOT  */
  YYSYMBOL_CR = 178,                       /* CR  */
  YYSYMBOL_COLON = 179,                    /* COLON  */
  YYSYMBOL_ANY = 180,                      /* ANY  */
  YYSYMBOL_ANYCAST = 181,                  /* ANYCAST  */
  YYSYMBOL_SCRIPTVARERR = 182,             /* SCRIPTVARERR  */
  YYSYMBOL_SCALE_UP_TO = 183,              /* SCALE_UP_TO  */
  YYSYMBOL_SCALE_DOWN_TO = 184,            /* SCALE_DOWN_TO  */
  YYSYMBOL_ON = 185,                       /* ON  */
  YYSYMBOL_CYCLES = 186,                   /* CYCLES  */
  YYSYMBOL_CYCLES_WITHIN = 187,            /* CYCLES_WITHIN  */
  YYSYMBOL_PERCENTAGE = 188,               /* PERCENTAGE  */
  YYSYMBOL_YYACCEPT = 189,                 /* $accept  */
  YYSYMBOL_cfg = 190,                      /* cfg  */
  YYSYMBOL_statements = 191,               /* statements  */
  YYSYMBOL_statement = 192,                /* statement  */
  YYSYMBOL_193_1 = 193,                    /* $@1  */
  YYSYMBOL_194_2 = 194,                    /* $@2  */
  YYSYMBOL_195_3 = 195,                    /* $@3  */
  YYSYMBOL_196_4 = 196,                    /* $@4  */
  YYSYMBOL_197_5 = 197,                    /* $@5  */
  YYSYMBOL_198_6 = 198,                    /* $@6  */
  YYSYMBOL_199_7 = 199,                    /* $@7  */
  YYSYMBOL_200_8 = 200,                    /* $@8  */
  YYSYMBOL_201_9 = 201,                    /* $@9  */
  YYSYMBOL_listen_id = 202,                /* listen_id  */
  YYSYMBOL_host_sep = 203,                 /* host_sep  */
  YYSYMBOL_host = 204,                     /* host  */
  YYSYMBOL_proto = 205,                    /* proto  */
  YYSYMBOL_port = 206,                     /* port  */
  YYSYMBOL_snumber = 207,                  /* snumber  */
  YYSYMBOL_phostport = 208,                /* phostport  */
  YYSYMBOL_panyhostport = 209,             /* panyhostport  */
  YYSYMBOL_alias_def = 210,                /* alias_def  */
  YYSYMBOL_id_lst = 211,                   /* id_lst  */
  YYSYMBOL_listen_id_def = 212,            /* listen_id_def  */
  YYSYMBOL_socket_def_param = 213,         /* socket_def_param  */
  YYSYMBOL_socket_def_params = 214,        /* socket_def_params  */
  YYSYMBOL_socket_def = 215,               /* socket_def  */
  YYSYMBOL_216_10 = 216,                   /* $@10  */
  YYSYMBOL_217_11 = 217,                   /* $@11  */
  YYSYMBOL_any_proto = 218,                /* any_proto  */
  YYSYMBOL_multi_string = 219,             /* multi_string  */
  YYSYMBOL_blst_elem = 220,                /* blst_elem  */
  YYSYMBOL_blst_elem_list = 221,           /* blst_elem_list  */
  YYSYMBOL_auto_scale_profile_def = 222,   /* auto_scale_profile_def  */
  YYSYMBOL_assign_stm = 223,               /* assign_stm  */
  YYSYMBOL_module_stm = 224,               /* module_stm  */
  YYSYMBOL_ip = 225,                       /* ip  */
  YYSYMBOL_ipv4 = 226,                     /* ipv4  */
  YYSYMBOL_ipv6addr = 227,                 /* ipv6addr  */
  YYSYMBOL_ipv6 = 228,                     /* ipv6  */
  YYSYMBOL_ipnet = 229,                    /* ipnet  */
  YYSYMBOL_folded_string = 230,            /* folded_string  */
  YYSYMBOL_route_name = 231,               /* route_name  */
  YYSYMBOL_route_name_var = 232,           /* route_name_var  */
  YYSYMBOL_route_stm = 233,                /* route_stm  */
  YYSYMBOL_failure_route_stm = 234,        /* failure_route_stm  */
  YYSYMBOL_onreply_route_stm = 235,        /* onreply_route_stm  */
  YYSYMBOL_branch_route_stm = 236,         /* branch_route_stm  */
  YYSYMBOL_error_route_stm = 237,          /* error_route_stm  */
  YYSYMBOL_local_route_stm = 238,          /* local_route_stm  */
  YYSYMBOL_startup_route_stm = 239,        /* startup_route_stm  */
  YYSYMBOL_timer_route_stm = 240,          /* timer_route_stm  */
  YYSYMBOL_event_route_stm = 241,          /* event_route_stm  */
  YYSYMBOL_exp = 242,                      /* exp  */
  YYSYMBOL_equalop = 243,                  /* equalop  */
  YYSYMBOL_compop = 244,                   /* compop  */
  YYSYMBOL_matchop = 245,                  /* matchop  */
  YYSYMBOL_intop = 246,                    /* intop  */
  YYSYMBOL_strop = 247,                    /* strop  */
  YYSYMBOL_script_var = 248,               /* script_var  */
  YYSYMBOL_exp_elem = 249,                 /* exp_elem  */
  YYSYMBOL_exp_cond = 250,                 /* exp_cond  */
  YYSYMBOL_assignop = 251,                 /* assignop  */
  YYSYMBOL_assignexp = 252,                /* assignexp  */
  YYSYMBOL_assign_cmd = 253,               /* assign_cmd  */
  YYSYMBOL_exp_stm = 254,                  /* exp_stm  */
  YYSYMBOL_brk_stm = 255,                  /* brk_stm  */
  YYSYMBOL_stm = 256,                      /* stm  */
  YYSYMBOL_actions = 257,                  /* actions  */
  YYSYMBOL_brk_actions = 258,              /* brk_actions  */
  YYSYMBOL_action = 259,                   /* action  */
  YYSYMBOL_brk_action = 260,               /* brk_action  */
  YYSYMBOL_brk_if_cmd = 261,               /* brk_if_cmd  */
  YYSYMBOL_if_cmd = 262,                   /* if_cmd  */
  YYSYMBOL_while_cmd = 263,                /* while_cmd  */
  YYSYMBOL_foreach_cmd = 264,              /* foreach_cmd  */
  YYSYMBOL_switch_cmd = 265,               /* switch_cmd  */
  YYSYMBOL_switch_stm = 266,               /* switch_stm  */
  YYSYMBOL_case_stms = 267,                /* case_stms  */
  YYSYMBOL_case_stm = 268,                 /* case_stm  */
  YYSYMBOL_default_stm = 269,              /* default_stm  */
  YYSYMBOL_func_param = 270,               /* func_param  */
  YYSYMBOL_route_param = 271,              /* route_param  */
  YYSYMBOL_async_func = 272,               /* async_func  */
  YYSYMBOL_cmd = 273                       /* cmd  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  206
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2118

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  189
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  85
/* YYNRULES -- Number of rules.  */
#define YYNRULES  470
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  902

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   443


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   481,   481,   484,   485,   486,   489,   490,   491,   491,
     492,   492,   493,   493,   494,   494,   495,   495,   496,   496,
     497,   497,   498,   498,   499,   499,   501,   504,   519,   528,
     543,   544,   547,   548,   562,   567,   577,   578,   581,   582,
     583,   587,   589,   591,   596,   602,   604,   608,   610,   612,
     614,   618,   621,   622,   625,   627,   629,   635,   638,   641,
     644,   647,   652,   653,   656,   657,   658,   658,   663,   663,
     670,   671,   673,   674,   677,   685,   696,   697,   698,   702,
     710,   718,   724,   732,   736,   737,   738,   739,   740,   744,
     746,   749,   750,   754,   755,   761,   762,   763,   764,   765,
     766,   767,   768,   769,   770,   771,   772,   773,   774,   775,
     776,   777,   778,   779,   780,   781,   782,   783,   784,   785,
     789,   790,   793,   797,   798,   799,   807,   815,   823,   831,
     839,   847,   855,   863,   871,   879,   882,   883,   886,   887,
     888,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     907,   908,   922,   923,   924,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,   935,   936,   937,   947,   957,
     958,   961,   962,   965,   969,   970,   973,   974,   977,   978,
     982,   983,   986,   987,   990,   991,   998,   999,  1006,  1008,
    1011,  1012,  1015,  1016,  1023,  1024,  1031,  1032,  1039,  1040,
    1042,  1043,  1047,  1048,  1051,  1052,  1054,  1055,  1057,  1059,
    1061,  1062,  1063,  1064,  1066,  1067,  1074,  1077,  1085,  1088,
    1132,  1133,  1138,  1140,  1142,  1143,  1149,  1151,  1165,  1167,
    1170,  1171,  1174,  1175,  1182,  1183,  1190,  1191,  1195,  1223,
    1224,  1226,  1227,  1230,  1231,  1234,  1235,  1245,  1247,  1249,
    1250,  1252,  1253,  1255,  1258,  1260,  1263,  1264,  1267,  1269,
    1272,  1275,  1279,  1280,  1286,  1292,  1296,  1297,  1300,  1316,
    1332,  1333,  1336,  1342,  1352,  1362,  1373,  1376,  1385,  1390,
    1413,  1418,  1426,  1442,  1445,  1451,  1454,  1462,  1468,  1471,
    1477,  1480,  1488,  1491,  1499,  1502,  1510,  1513,  1526,  1529,
    1535,  1540,  1541,  1542,  1543,  1544,  1545,  1548,  1549,  1552,
    1553,  1554,  1555,  1557,  1558,  1561,  1562,  1565,  1566,  1567,
    1570,  1586,  1591,  1592,  1593,  1595,  1600,  1603,  1606,  1609,
    1612,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,
    1627,  1631,  1632,  1633,  1634,  1635,  1636,  1639,  1642,  1645,
    1648,  1651,  1654,  1657,  1660,  1663,  1666,  1669,  1672,  1685,
    1698,  1713,  1714,  1715,  1716,  1717,  1720,  1721,  1722,  1725,
    1726,  1727,  1730,  1731,  1732,  1736,  1737,  1738,  1741,  1742,
    1743,  1744,  1745,  1746,  1747,  1748,  1751,  1752,  1753,  1754,
    1755,  1756,  1757,  1758,  1759,  1762,  1770,  1780,  1788,  1798,
    1806,  1824,  1833,  1834,  1836,  1837,  1840,  1846,  1852,  1858,
    1866,  1869,  1872,  1877,  1887,  1894,  1901,  1911,  1916,  1923,
    1933,  1938,  1945,  1957,  1962,  1967,  1972,  1977,  1987,  1997,
    2007,  2019,  2037,  2068,  2072,  2078,  2081,  2082,  2083,  2084,
    2085,  2087,  2089,  2091,  2093,  2095,  2096,  2099,  2105,  2106,
    2108,  2114,  2115,  2117,  2121,  2140,  2141,  2143,  2166,  2202,
    2204,  2207,  2209,  2211,  2213,  2215,  2217,  2219,  2225,  2231,
    2237
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "DROP", "ASSERT",
  "EXIT", "RETURN", "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_BRANCH", "ROUTE_ERROR", "ROUTE_LOCAL",
  "ROUTE_STARTUP", "ROUTE_TIMER", "ROUTE_EVENT", "IF", "ELSE", "SWITCH",
  "CASE", "DEFAULT", "BREAK", "WHILE", "FOR", "IN", "NULLV", "XDBG",
  "XLOG", "XLOG_BUF_SIZE", "XLOG_FORCE_COLOR", "XLOG_PRINT_LEVEL",
  "XLOG_LEVEL", "PV_PRINT_BUF_SIZE", "DEBUG_MODE", "ENABLE_ASSERTS",
  "ABORT_ON_ASSERT", "LOGLEVEL", "LOGSTDOUT", "LOGSTDERROR", "LOGFACILITY",
  "LOGNAME", "AVP_ALIASES", "LISTEN", "SOCKET", "MEMGROUP", "ALIAS",
  "AUTO_ALIASES", "TAG", "DNS", "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR",
  "DNS_RETR_TIME", "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH",
  "MAX_WHILE_LOOPS", "UDP_WORKERS", "CHECK_VIA",
  "SHM_HASH_SPLIT_PERCENTAGE", "SHM_SECONDARY_HASH_SIZE",
  "MEM_WARMING_ENABLED", "MEM_WARMING_PATTERN_FILE",
  "MEM_WARMING_PERCENTAGE", "RPM_MEM_FILE", "RPM_MEM_SIZE", "MEMLOG",
  "MEMDUMP", "EXECMSGTHRESHOLD", "EXECDNSTHRESHOLD", "TCPTHRESHOLD",
  "EVENT_SHM_THRESHOLD", "EVENT_PKG_THRESHOLD", "QUERYBUFFERSIZE",
  "QUERYFLUSHTIME", "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER",
  "USER_AGENT_HEADER", "LOADMODULE", "MPATH", "MODPARAM", "MAXBUFFER",
  "CHROOT", "WDIR", "MHOMED", "POLL_METHOD", "TCP_ACCEPT_ALIASES",
  "TCP_WORKERS", "TCP_CONNECT_TIMEOUT", "TCP_CON_LIFETIME",
  "TCP_LISTEN_BACKLOG", "TCP_SOCKET_BACKLOG", "TCP_MAX_CONNECTIONS",
  "TCP_NO_NEW_CONN_BFLAG", "TCP_NO_NEW_CONN_RPLFLAG", "TCP_KEEPALIVE",
  "TCP_KEEPCOUNT", "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE", "OPEN_FD_LIMIT",
  "MCAST_LOOPBACK", "MCAST_TTL", "TOS", "DISABLE_DNS_FAILOVER",
  "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST", "DISABLE_STATELESS_FWD",
  "DB_VERSION_TABLE", "DB_DEFAULT_URL", "DB_MAX_ASYNC_CONNECTIONS",
  "DISABLE_503_TRANSLATION", "SYNC_TOKEN", "ASYNC_TOKEN", "LAUNCH_TOKEN",
  "AUTO_SCALING_PROFILE", "AUTO_SCALING_CYCLE", "TIMER_WORKERS", "EQUAL",
  "EQUAL_T", "GT", "LT", "GTE", "LTE", "DIFF", "MATCH", "NOTMATCH",
  "COLONEQ", "PLUSEQ", "MINUSEQ", "SLASHEQ", "MULTEQ", "MODULOEQ",
  "BANDEQ", "BOREQ", "BXOREQ", "OR", "AND", "BOR", "BAND", "BXOR",
  "BLSHIFT", "BRSHIFT", "PLUS", "MINUS", "MULT", "MODULO", "NOT", "BNOT",
  "NUMBER", "ZERO", "ID", "STRING", "SCRIPTVAR", "IPV6ADDR", "IPV4ADDR",
  "IPNET", "COMMA", "SEMICOLON", "RPAREN", "LPAREN", "LBRACE", "RBRACE",
  "LBRACK", "RBRACK", "SLASH", "AS", "USE_WORKERS",
  "USE_AUTO_SCALING_PROFILE", "MAX", "MIN", "DOT", "CR", "COLON", "ANY",
  "ANYCAST", "SCRIPTVARERR", "SCALE_UP_TO", "SCALE_DOWN_TO", "ON",
  "CYCLES", "CYCLES_WITHIN", "PERCENTAGE", "$accept", "cfg", "statements",
  "statement", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "listen_id", "host_sep", "host", "proto", "port", "snumber",
  "phostport", "panyhostport", "alias_def", "id_lst", "listen_id_def",
  "socket_def_param", "socket_def_params", "socket_def", "$@10", "$@11",
  "any_proto", "multi_string", "blst_elem", "blst_elem_list",
  "auto_scale_profile_def", "assign_stm", "module_stm", "ip", "ipv4",
  "ipv6addr", "ipv6", "ipnet", "folded_string", "route_name",
  "route_name_var", "route_stm", "failure_route_stm", "onreply_route_stm",
  "branch_route_stm", "error_route_stm", "local_route_stm",
  "startup_route_stm", "timer_route_stm", "event_route_stm", "exp",
  "equalop", "compop", "matchop", "intop", "strop", "script_var",
  "exp_elem", "exp_cond", "assignop", "assignexp", "assign_cmd", "exp_stm",
  "brk_stm", "stm", "actions", "brk_actions", "action", "brk_action",
  "brk_if_cmd", "if_cmd", "while_cmd", "foreach_cmd", "switch_cmd",
  "switch_stm", "case_stms", "case_stm", "default_stm", "func_param",
  "route_param", "async_func", "cmd", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443
};
#endif

#define YYPACT_NINF (-773)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-411)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1940,   -77,   -67,   -29,   -17,    -1,    19,   215,   220,   232,
     235,   246,   258,   268,   273,   275,   316,   395,   417,   432,
     458,   460,    22,    24,   370,   371,   399,   476,   531,   532,
     536,   563,   567,   579,   591,   600,   608,   625,   627,   629,
     656,   660,   679,   685,   692,   693,   706,   707,   709,   711,
     712,    15,   727,     9,   729,   735,   738,   744,   746,   757,
     760,   761,   771,   784,   796,   798,   800,   803,   805,   807,
     808,   809,   816,   817,   819,   820,   821,   824,   826,   827,
     559,   582,   828,   842,   843,   844,   846,   847,   849,   851,
     853,  -773,   139,  1811,  -773,    82,    34,   233,   422,   592,
     459,   530,   539,   587,  -773,  -773,  -773,   319,   329,   346,
     310,   347,   348,   349,   359,   652,   363,   366,    93,    25,
      79,   252,   522,    31,   375,   376,   379,  -773,   557,  -773,
     620,  -773,   823,  -773,   831,  -773,   834,  -773,   835,   380,
     382,   385,   389,   403,   404,    27,   409,    91,   416,   313,
     326,   421,   431,   435,   454,   466,   471,   481,   482,   484,
     120,   149,  -773,  -773,   150,  -773,   584,   485,   104,   119,
     514,   136,   515,   537,   538,   541,   542,   546,   556,   128,
     133,   571,   586,   602,   609,   613,   171,   614,   617,   618,
     619,   621,   309,  -773,   837,  -773,   839,   589,   841,   157,
     158,   645,   649,   234,   650,   848,  -773,   -77,  -773,    12,
    -773,     5,  -773,    13,  -773,    58,  -773,    80,  -773,    81,
    -773,    88,  -773,    60,  -773,    62,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,   850,   852,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,   978,  -773,   804,   549,
     605,  -773,  -773,  -773,   812,  -773,   818,  -773,  -773,  -773,
     822,   840,  -773,   -78,   845,  -773,  1229,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,   825,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,   838,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,   832,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,   854,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,   815,  -773,  -773,  -773,   857,  -773,  1651,
     527,  -773,   527,  -773,  1651,   527,  -773,   527,  -773,  1651,
    -773,  1651,  -773,  1651,  -773,   527,  -773,   527,  -773,  -773,
    -773,  1254,   651,   651,   160,   856,   722,  -773,   239,   863,
     722,  -773,   864,   865,   871,   855,   879,   887,   880,   881,
     882,   787,    11,    51,    53,   883,   885,   891,   894,   900,
     902,   904,   905,    92,  -773,  -773,  -773,  1618,   889,   670,
    -773,  -773,  -773,  -773,  -773,    23,  -773,  -773,  -773,   875,
     903,   730,   916,   917,   790,   836,   868,   909,   919,   911,
     912,   936,   722,   940,   941,  -773,   651,  -773,  -773,  -773,
     939,  -773,  -773,   920,  -773,  -773,  -773,   943,  -773,  -111,
     918,  -773,   937,  1288,   942,   -33,  -773,  -773,  -773,   229,
    -773,   231,  -773,   124,  1288,   -58,  1288,   -58,   950,   951,
     953,   953,  -773,    44,   975,  1084,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -773,  1388,  -773,  -773,  -773,  -773,  -773,
    -773,   945,   947,  -773,   949,   952,  -773,  -773,  -773,   962,
     954,   -53,    35,  -773,   955,  -773,  -773,  -773,  -773,  -773,
      61,   -14,   966,   165,  -773,    70,   963,  -773,  1288,  1288,
    1485,  1388,  -773,   195,  1557,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,   957,   968,   970,   971,   974,   976,   980,
     979,  -773,   -52,  -773,   492,   983,   516,  1113,  -117,   210,
     -18,   256,   108,   982,   161,   984,  -773,   708,  -773,  -773,
    -773,   260,  -773,  -773,  1388,  -773,  1388,  -773,  1039,  -773,
    1373,  -773,  1651,  1651,  1651,  1651,   986,  1651,  -773,  -773,
    -773,  -773,  -773,    63,  -773,  -773,   987,  1008,   165,  -773,
    -773,  1012,  -773,  -111,  -773,  1024,  -773,   524,  -773,   910,
     755,  1288,  1288,  1019,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,   419,   -44,  -773,   652,   -40,  -773,  -773,  -773,
    -773,  1022,  -773,  1023,  -773,   298,  -773,  1553,  1017,  1320,
     -58,  -773,  -773,  -773,  -773,  1027,  -773,  -773,  -773,   253,
     527,   527,  -773,  -773,  -773,  -773,  -773,   906,  -773,  -773,
    1281,  1388,  1388,  1388,  1388,  1388,  1388,  1388,  1388,  1388,
    1388,   956,  1034,  1076,  1122,  1020,  1154,  -773,  -773,  -773,
    -773,  1025,   686,  -773,  1161,  -773,  -773,  -773,  -773,  -773,
    1029,  -773,  -773,  -773,  -773,  -773,  -773,  -773,  1032,  1035,
    -773,  -773,  -773,  -773,   478,  1582,  1170,  -773,  1169,  1026,
    1046,  -773,  1347,  1047,  -773,  -773,  -773,  -773,  -773,  -773,
      37,  1048,   262,   480,  1049,  -773,   622,   663,  1050,  -773,
    -773,  -773,  -773,   611,   611,   611,   611,   611,  -773,  -773,
    -773,  -773,  -773,  -773,  -773,  -773,  -773,  1651,  -773,   686,
    1036,  1057,  -773,  -773,  -773,   338,  -773,  -773,  1200,  1553,
     570,  1051,   448,  -773,  1288,  -773,  -773,   588,  -773,  -773,
    -773,  -773,  1320,  -773,  -773,  -773,  -773,  1062,  -773,  -773,
    1242,  1058,   -53,   148,  -773,  -773,  -773,  -773,  -773,  -773,
    1043,  1044,  -773,  1052,  -773,  -773,   575,  -773,  -773,  -773,
    -773,  1061,  -773,   -53,  1064,  1053,  1075,  1609,  1609,  1609,
    1320,  -773,  1069,  1078,  1079,  1054,   504,   545,   624,  1220,
    1094,  1088,  1070,  1099,  1320,  1091,  -773,  1102,  1074,  -773,
    -773,  1109,  1108,  1239,  1116,  1110,  1244,  1086,  1120,  -773,
    1090,  -773
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    26,     0,     0,     4,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     6,     7,   260,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   103,     0,   105,
       0,   107,     0,   109,     0,   111,     0,   113,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   262,   261,     0,   265,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   243,     0,   245,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,     5,     3,     0,
       9,     0,    11,     0,    13,     0,    15,     0,    17,     0,
      19,     0,    21,     0,    23,     0,    25,   210,   207,   211,
     208,   212,   209,   214,     0,     0,    38,   213,   206,   205,
      89,    88,    85,    84,    87,    86,    83,    91,    90,    93,
      92,    95,    94,    97,    96,   218,     0,    35,     0,    65,
      64,   217,   216,   215,     0,   222,    32,    28,   269,   268,
       0,     0,    47,    29,     0,    51,    52,   221,    27,   266,
     270,   267,   224,   223,    99,    98,   101,   100,   102,   104,
     106,   108,   110,   112,   115,   114,   120,   118,   124,   123,
     126,   125,   128,   127,   130,   129,   132,   131,   134,   133,
     136,   135,   138,   137,   140,   139,   142,   141,   144,   143,
     146,   145,   148,   147,   150,   149,   152,   151,   154,   153,
     156,   155,   158,   157,   200,   199,   202,   201,   204,   203,
     241,   240,     0,   117,   116,   161,   160,   159,   164,   163,
     162,   166,   165,   169,   167,   168,   171,   170,   174,   172,
     176,   175,   178,   177,   180,   179,   182,   181,   184,   183,
     186,   185,   188,   187,   190,   189,   194,   193,   196,   195,
     198,   197,   192,   191,   226,    32,   225,   228,   227,   230,
     229,   232,   231,   234,   233,   236,   235,   239,   237,   238,
     242,   244,     0,   247,   249,   248,   251,   250,   253,   252,
     255,   254,   257,     0,   256,   259,   258,   121,   283,     0,
       0,   285,     0,   288,     0,     0,   290,     0,   292,     0,
     294,     0,   296,     0,   298,     0,   300,     0,    39,    40,
      44,     0,     0,     0,     0,     0,     0,    31,     0,     0,
       0,    53,     0,     0,     0,     0,     0,     0,   436,     0,
     438,   445,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   320,   384,   321,     0,     0,     0,
     373,   379,   380,   381,   382,     0,   277,   276,   278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      41,     0,     0,     0,     0,    57,    62,    69,    67,   220,
      72,   219,   271,    48,    34,    33,   119,     0,   173,     0,
       0,   122,     0,     0,     0,     0,   442,   440,   448,     0,
     451,     0,   455,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   460,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,   383,   374,   281,   372,   385,
     378,     0,     0,   286,     0,     0,   291,   293,   295,     0,
       0,     0,     0,    60,    54,    59,    58,    61,    63,    73,
       0,     0,     0,     0,    77,     0,     0,   437,     0,     0,
       0,     0,   324,     0,   325,   306,   322,   363,   323,   362,
     361,   439,   444,     0,     0,     0,     0,     0,     0,     0,
       0,   279,     0,   280,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   412,   414,   457,   417,
     420,     0,   359,   360,     0,   342,     0,   341,   343,   344,
     358,   345,     0,     0,     0,     0,     0,     0,    36,    37,
      46,    43,    42,     0,    50,    49,     0,     0,     0,    70,
      71,     0,    78,     0,   246,     0,   303,     0,   365,     0,
       0,     0,     0,     0,   307,   309,   310,   311,   312,   308,
     313,   314,   315,   316,   319,     0,     0,   443,   441,   449,
     446,     0,   452,     0,   456,     0,   453,     0,     0,     0,
       0,   274,   461,   275,   462,     0,   463,   464,   434,     0,
       0,     0,   470,   459,   415,   418,   421,   416,   458,   356,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    56,    55,   263,
     264,     0,     0,    76,     0,   304,   364,   305,   302,   301,
       0,   329,   272,   273,   330,   328,   327,   326,     0,     0,
     425,   423,   424,   426,     0,     0,   397,   369,     0,     0,
       0,   393,     0,     0,   399,   366,   388,   389,   390,   391,
       0,     0,     0,     0,     0,   431,     0,     0,     0,   413,
     419,   422,   357,   352,   351,   353,   354,   355,   346,   347,
     348,   350,   349,   282,   284,   287,   289,     0,   299,     0,
       0,     0,   435,   447,   450,     0,   454,   371,     0,     0,
       0,     0,   403,   405,     0,   386,   368,     0,   376,   392,
     394,   387,     0,   465,   466,   433,   432,     0,   467,   469,
       0,     0,     0,     0,   430,   427,   428,   429,   370,   398,
       0,     0,   401,     0,   404,   402,     0,   377,   367,   375,
     400,     0,   297,     0,     0,    82,     0,   409,   407,   411,
       0,   468,     0,     0,     0,    81,     0,     0,     0,   395,
       0,     0,     0,     0,     0,     0,    74,     0,     0,   396,
      75,     0,     0,     0,     0,     0,     0,     0,     0,    80,
       0,    79
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -773,  -773,  -773,  1184,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -166,  -773,  -773,  -122,  -550,  -110,   -37,
    -773,  -773,  1002,  -773,  -773,  -400,  1159,  -773,  -773,   626,
     772,   635,  -773,  -773,  -773,  -773,   -80,  -773,  1013,  -773,
    -705,  -449,  -369,  -773,  -773,  -773,  -773,  -773,  -773,  -773,
    -773,  -773,  -773,  -501,  -773,  -773,  -773,  -773,  -773,  -458,
    -773,  -519,  -773,   287,  -515,  -773,  -772,   468,  -422,  -102,
    -445,   -56,  -773,  -505,  -672,  -439,  -378,  -773,  -773,   463,
    -773,   580,  -773,   747,  -426
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   272,   449,   273,   258,   650,   637,   259,
     260,   276,   277,   575,   506,   507,   261,   443,   442,   661,
     511,   584,   585,   414,   104,   105,   278,   279,   280,   281,
     754,   619,   489,   612,   210,   212,   214,   216,   218,   220,
     222,   224,   226,   593,   682,   683,   684,   685,   686,   477,
     595,   639,   554,   640,   478,   598,   774,   766,   479,   827,
     480,   775,   776,   481,   482,   483,   484,   821,   822,   823,
     855,   631,   764,   623,   485
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     237,   274,   491,   527,   596,   246,   421,   494,   597,   495,
     165,   496,   528,   418,   423,   596,   162,   596,   599,   597,
     386,   597,   652,   127,   559,   129,   253,   777,   306,   599,
     655,   599,   265,   614,   558,   616,   651,   810,   830,   315,
     317,   701,   582,   508,   211,   625,   558,   106,   702,   558,
     558,   558,   530,   490,   532,   583,   492,   107,   493,   426,
     860,   434,   654,   436,   737,   594,   497,   604,   498,   596,
     596,   662,   447,   597,   597,   613,   594,   615,   594,   617,
     255,   428,   430,   599,   599,   630,   275,   666,   667,   432,
     621,   209,   310,   542,   251,   108,   638,   600,   879,   448,
     777,   474,   648,   738,   841,   345,   578,   109,   600,   708,
     600,   695,   889,   696,  -318,  -318,   234,   235,   756,   474,
     348,   336,   236,   110,   476,   610,   474,   649,   641,   370,
     594,   594,   602,   638,   372,   234,   235,   353,  -318,   206,
     701,   236,   476,   111,   656,   705,   128,   706,   130,   476,
     338,   340,   596,   596,   274,   777,   597,   597,   404,   406,
     777,   509,   600,   600,   611,   641,   599,   599,   669,   716,
     748,   749,   384,   163,   422,   166,   638,   529,   638,   419,
     424,   420,   425,   254,   773,   307,   256,   560,   266,   267,
     648,   268,   269,   234,   235,   777,   777,   777,   777,   236,
     270,   831,   626,   474,   777,   777,   777,   627,   641,   628,
     641,   271,   777,   594,   594,   649,   648,   531,   648,   533,
     731,   732,   733,   734,   558,   736,   476,   427,   757,   435,
     605,   437,   608,   663,   256,   412,   257,   763,   664,   275,
     514,   649,   781,   649,   213,   600,   600,   429,   431,   311,
     252,   630,   767,   262,   784,   433,   783,   773,   543,   791,
     778,   346,   347,   638,   638,   638,   638,   638,   638,   638,
     638,   638,   638,   780,   709,   500,   349,   350,   337,   486,
     513,   487,   488,   474,   500,   371,   558,   558,   558,   558,
     373,   558,   864,   354,   355,   641,   641,   641,   641,   641,
     641,   641,   641,   641,   641,   596,   476,   339,   341,   597,
     397,   233,   773,   872,   314,   405,   407,   773,   510,   599,
     227,   779,   257,   856,   711,   760,   712,   316,   385,   267,
     229,   268,   269,   778,   865,   866,   574,   671,   672,   112,
     270,   787,   788,   818,   113,   659,   780,   231,   238,   240,
     242,   526,   773,   773,   773,   773,   114,   847,   673,   115,
     244,   773,   773,   773,   247,   844,   594,   249,   703,   773,
     116,   131,   133,   558,   767,   704,   282,   284,   234,   235,
     286,   294,   117,   296,   236,   840,   298,   606,   778,   609,
     300,   413,   118,   778,   779,   558,   -30,   119,   600,   120,
     135,   780,   234,   235,   302,   304,   780,   256,   236,   257,
     308,   626,   474,   592,   703,   603,   627,   312,   785,   607,
     701,   707,   318,   717,   592,   718,   592,   833,   778,   778,
     778,   778,   320,   629,   215,   476,   322,   778,   778,   778,
     121,   780,   780,   780,   780,   778,   751,   234,   235,   779,
     780,   780,   780,   236,   779,   324,   761,   474,   780,   234,
     235,   660,   234,   235,   398,   236,   399,   326,   236,   820,
     853,   657,   328,   219,   228,   234,   235,   137,   592,   592,
     476,   236,   330,   332,   230,   334,   343,   234,   235,   779,
     779,   779,   779,   236,   132,   134,   845,   474,   779,   779,
     779,   232,   239,   241,   243,   857,   779,   458,   459,   460,
     461,   462,   463,   464,   245,   351,   356,   715,   248,   122,
     476,   250,   769,   136,   466,  -408,  -408,   770,   467,   468,
     283,   285,   469,   470,   287,   295,   660,   297,   358,   360,
     299,   123,   362,   364,   301,   221,   857,   366,   458,   459,
     460,   461,   462,   463,   464,   223,   124,   368,   303,   305,
     193,   592,   592,   769,   309,   466,  -406,  -406,   770,   467,
     468,   313,   374,   469,   470,   755,   319,  -317,  -317,   268,
     269,   752,   125,   195,   126,   762,   321,   376,   270,   857,
     323,   458,   459,   460,   461,   462,   463,   464,   -68,   629,
     138,  -317,   753,   378,   225,   217,   769,   790,   466,   325,
     380,   770,   467,   468,   382,   387,   469,   470,   389,   391,
     393,   327,   395,   471,   472,   857,   329,   458,   459,   460,
     461,   462,   463,   464,   671,   672,   331,   333,   703,   335,
     344,   815,   769,   816,   466,   834,   408,   770,   467,   468,
     410,   415,   469,   470,   -66,   139,   140,   697,   671,   672,
     141,   473,   753,   474,   471,   472,   671,   672,   771,   352,
     357,   556,  -408,   458,   459,   460,   461,   462,   463,   464,
     264,   699,   486,   194,   487,   488,   476,   142,   465,   745,
     466,   143,   359,   361,   467,   468,   363,   365,   469,   470,
     501,   367,   473,   144,   474,   846,   196,   471,   472,   771,
     851,   369,   288,  -406,   592,   145,   828,   671,   672,   234,
     235,   -68,   -68,   -68,   146,   236,   375,   476,   850,   753,
     -68,   556,   147,   458,   459,   460,   461,   462,   463,   464,
     870,   377,   342,   471,   472,   473,   402,   474,   465,   148,
     466,   149,   771,   150,   467,   468,   858,   379,   469,   470,
     726,   727,   728,   729,   381,   876,   877,   878,   383,   388,
     476,   859,   390,   392,   394,   289,   396,   -66,   -66,   -66,
     151,   473,   730,   474,   152,   717,   -66,   836,   771,   471,
     472,   556,  -410,   458,   459,   460,   461,   462,   463,   464,
     409,   234,   235,   153,   411,   416,   476,   236,   465,   154,
     466,   828,   828,   828,   467,   468,   155,   156,   469,   470,
     859,   859,   859,   502,   503,   504,   837,   473,   838,   474,
     157,   158,   505,   159,   475,   160,   161,   556,   557,   458,
     459,   460,   461,   462,   463,   464,   268,   269,   752,   471,
     472,   164,   476,   167,   465,   270,   466,   234,   235,   168,
     467,   468,   169,   236,   469,   470,   714,   474,   170,   556,
     171,   458,   459,   460,   461,   462,   463,   464,   670,   385,
     267,   172,   268,   269,   173,   174,   465,   473,   466,   474,
     476,   270,   467,   468,   475,   175,   469,   470,   563,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   176,   471,
     472,   556,   476,   458,   459,   460,   461,   462,   463,   464,
     177,   719,   178,   720,   179,   747,   730,   180,   465,   181,
     466,   182,   183,   184,   467,   468,   234,   235,   469,   470,
     185,   186,   236,   187,   188,   189,   474,   473,   190,   474,
     191,   192,   197,   525,   475,   471,   472,   556,   566,   458,
     459,   460,   461,   462,   463,   464,   198,   199,   200,   476,
     201,   202,   476,   203,   465,   204,   466,   205,   290,   440,
     467,   468,   268,   441,   469,   470,   291,   471,   472,   292,
     293,   444,   400,   473,   401,   474,   403,   -35,   456,   452,
     475,   453,   632,   417,   567,   438,   454,   439,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   476,   446,
     515,   516,   519,   517,   450,   473,   512,   474,   518,   471,
     472,   457,   475,   455,   520,   556,   568,   458,   459,   460,
     461,   462,   463,   464,   521,   561,   522,   523,   524,   534,
     476,   535,   465,   555,   466,   234,   235,   536,   467,   468,
     537,   236,   469,   470,   789,   474,   538,   473,   539,   474,
     540,   541,   569,   562,   475,   471,   472,   556,   746,   458,
     459,   460,   461,   462,   463,   464,   564,   565,   476,   570,
     571,   572,   476,   573,   465,   576,   466,   510,   577,   580,
     467,   468,   587,   586,   469,   470,   581,   601,   618,   620,
     622,   633,   642,   473,   643,   474,   644,   646,   665,   645,
     475,   647,   687,   556,   803,   458,   459,   460,   461,   462,
     463,   464,   658,   688,   653,   689,   690,   691,   476,   700,
     465,   692,   466,   693,   694,   710,   467,   468,   698,   713,
     469,   470,   739,   471,   472,   556,   735,   458,   459,   460,
     461,   462,   463,   464,   674,   675,   676,   677,   678,   679,
     680,   681,   465,   740,   466,   742,   744,   750,   467,   468,
     758,   759,   469,   470,   768,   782,   811,   807,   809,   819,
     820,   473,   824,   474,   812,   471,   472,   813,   475,   842,
     814,   556,   804,   458,   459,   460,   461,   462,   463,   464,
     825,   829,   843,   832,   835,   839,   476,   861,   465,   852,
     466,   863,   867,   868,   467,   468,   871,   873,   469,   470,
     875,   869,   880,   473,   882,   474,   881,   874,   883,   884,
     475,   471,   472,   556,   805,   458,   459,   460,   461,   462,
     463,   464,   885,   886,   888,   887,   890,   891,   476,   892,
     465,   893,   466,   894,   895,   897,   467,   468,   896,   898,
     469,   470,   899,   471,   472,   900,   901,   208,   451,   473,
     263,   474,   579,   445,   741,   854,   475,   849,   624,   786,
     806,   458,   459,   460,   461,   462,   463,   464,   743,     0,
       0,     0,     0,     0,   476,     0,   465,     0,     0,     0,
       0,   473,     0,   474,     0,     0,   469,   470,   475,   471,
     472,     0,   808,   458,   459,   460,   461,   462,   463,   464,
       0,     0,     0,     0,     0,     0,   476,     0,   769,     0,
     466,     0,     0,   770,   467,   468,     0,     0,   469,   470,
     458,   459,   460,   461,   462,   463,   464,   473,     0,   474,
       0,   471,   472,     0,   475,   769,     0,   466,   848,     0,
     770,   467,   468,     0,     0,   469,   470,     0,     0,     0,
       0,     0,   476,     0,   256,     0,   266,   267,     0,   268,
     269,   458,   459,   460,   461,   462,   463,   464,   270,   473,
       0,   474,     0,     0,     0,   499,   475,   471,   472,   271,
     862,   385,   267,     0,   268,   269,   469,   470,     0,     0,
       0,     0,     0,   270,   476,   721,   722,   723,   724,   725,
     726,   727,   728,   729,     0,     0,     0,   234,   235,   471,
     472,   588,     0,   236,     0,   473,   792,   474,     0,     0,
       0,     0,   730,     0,   589,   590,     0,   591,     0,     0,
       0,     0,     0,     0,     0,     0,   471,   472,     0,     0,
     476,     0,     0,     0,     0,     0,     0,   473,     0,   474,
       0,     0,     0,     0,   771,     0,     0,   772,   458,   459,
     460,   461,   462,   463,   464,     0,     0,     0,     0,     0,
       0,     0,   476,   465,   473,   466,   474,   471,   472,   467,
     468,   771,     0,   469,   470,   826,     0,   721,   722,   723,
     724,   725,   726,   727,   728,   729,     0,     0,     0,   476,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
       0,     0,   634,   236,   730,   473,   635,   474,     0,     0,
       0,     0,     0,     0,   636,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,     0,     0,     0,     0,     0,
     476,   465,     0,   466,     0,     0,     0,   467,   468,     0,
       0,   469,   470,     0,     0,   458,   459,   460,   461,   462,
     463,   464,     0,     0,     0,     0,     0,     0,     0,     0,
     465,     0,   466,     0,   471,   472,   467,   468,     0,     0,
     469,   470,   458,   459,   460,   461,   462,   463,   464,     0,
       0,     0,     0,     0,     0,     0,     0,   769,     0,   466,
       0,     0,   770,   467,   468,     0,     0,   469,   470,     0,
       0,     0,   473,     0,   474,     0,     0,     0,     0,   475,
       0,     0,     0,   668,   458,   459,   460,   461,   462,   463,
     464,     0,     0,     0,     0,     0,     0,   476,     0,   465,
       0,   466,   471,   472,     0,   467,   468,     0,     0,   469,
     470,   544,   674,   675,   676,   677,   678,   679,   680,   681,
     545,   546,   547,   548,   549,   550,   551,   552,   553,     0,
       0,   471,   472,     0,     0,     0,     0,     0,     0,     0,
     473,     0,   474,     0,     0,     0,     0,   475,     0,     0,
     765,     0,     0,     0,     0,     0,     0,     0,   471,   472,
       0,     0,     0,     0,     0,   476,     0,     0,     0,   473,
       0,   474,   544,     0,     0,     0,   475,     0,     0,     0,
     817,   545,   546,   547,   548,   549,   550,   551,   552,   553,
       0,     0,     0,     0,   476,     0,   473,     0,   474,     0,
     471,   472,     0,   771,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   476,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   473,     0,
     474,    -2,   207,     0,     0,   475,     0,     0,     0,     0,
      -8,   -10,   -12,   -14,   -16,   -18,   -20,   -22,   -24,     0,
       0,     0,     0,   476,     0,     0,     0,     0,     0,     0,
       0,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,     0,    15,    16,    17,    18,    19,
       0,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     0,
       0,     0,    88,    89,    90,     0,     0,     0,     0,     0,
       0,     1,     0,     0,     0,     0,     0,     0,     0,    -8,
     -10,   -12,   -14,   -16,   -18,   -20,   -22,   -24,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,     0,    15,    16,    17,    18,    19,    91,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     0,     0,
       0,    88,    89,    90,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    91
};

static const yytype_int16 yycheck[] =
{
     110,   123,   424,   461,   523,   115,     1,   429,   523,   431,
       1,   433,     1,     1,     1,   534,     1,   536,   523,   534,
     186,   536,   572,     1,     1,     1,     1,   699,     1,   534,
     580,   536,     1,   534,   479,   536,     1,   742,     1,   149,
     150,   158,   153,   443,    10,     1,   491,   124,   165,   494,
     495,   496,     1,   422,     1,   166,   425,   124,   427,     1,
     832,     1,     1,     1,     1,   523,   435,   525,   437,   588,
     589,     1,   150,   588,   589,   533,   534,   535,   536,   537,
       1,     1,     1,   588,   589,   543,   123,   588,   589,     1,
     539,     9,     1,     1,     1,   124,   554,   523,   870,   177,
     772,   159,   155,   653,   809,     1,   506,   124,   534,     1,
     536,   163,   884,   165,   158,   159,   149,   150,   158,   159,
       1,     1,   155,   124,   182,     1,   159,   180,   554,     1,
     588,   589,   165,   591,     1,   149,   150,     1,   182,     0,
     158,   155,   182,   124,   158,   163,   124,   165,   124,   182,
       1,     1,   671,   672,   276,   827,   671,   672,     1,     1,
     832,     1,   588,   589,   533,   591,   671,   672,   590,   627,
     671,   672,     1,   158,   169,   166,   634,   166,   636,   167,
     167,   169,   169,   158,   699,   158,   155,   164,   157,   158,
     155,   160,   161,   149,   150,   867,   868,   869,   870,   155,
     169,   164,   158,   159,   876,   877,   878,   163,   634,   165,
     636,   180,   884,   671,   672,   180,   155,   166,   155,   166,
     642,   643,   644,   645,   669,   647,   182,   169,   686,   169,
       1,   169,     1,   163,   155,     1,   157,   695,   168,   276,
       1,   180,   700,   180,    11,   671,   672,   167,   167,   158,
     157,   709,   697,     1,     1,   167,   705,   772,   166,   717,
     699,   157,   158,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   699,   166,   441,   157,   158,   158,   155,
     446,   157,   158,   159,   450,   157,   731,   732,   733,   734,
     157,   736,   842,   157,   158,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   824,   182,   158,   158,   824,
       1,     1,   827,   863,     1,   158,   158,   832,   158,   824,
       1,   699,   157,   824,   163,    27,   165,     1,   157,   158,
       1,   160,   161,   772,   186,   187,   502,   142,   143,   124,
     169,   710,   711,   765,   124,   180,   772,     1,     1,     1,
       1,   461,   867,   868,   869,   870,   124,   815,   163,   124,
       1,   876,   877,   878,     1,    27,   824,     1,   158,   884,
     124,     1,     1,   818,   819,   165,     1,     1,   149,   150,
       1,     1,   124,     1,   155,   807,     1,   158,   827,   158,
       1,   157,   124,   832,   772,   840,   157,   124,   824,   124,
       1,   827,   149,   150,     1,     1,   832,   155,   155,   157,
       1,   158,   159,   523,   158,   525,   163,     1,   165,   529,
     158,   165,     1,   163,   534,   165,   536,   165,   867,   868,
     869,   870,     1,   543,    12,   182,     1,   876,   877,   878,
     124,   867,   868,   869,   870,   884,    27,   149,   150,   827,
     876,   877,   878,   155,   832,     1,   158,   159,   884,   149,
     150,   583,   149,   150,   155,   155,   157,     1,   155,    21,
      22,   581,     1,    14,   155,   149,   150,     1,   588,   589,
     182,   155,     1,     1,   155,     1,     1,   149,   150,   867,
     868,   869,   870,   155,   124,   124,   158,   159,   876,   877,
     878,   155,   155,   155,   155,     1,   884,     3,     4,     5,
       6,     7,     8,     9,   155,     1,     1,   627,   155,   124,
     182,   155,    18,   124,    20,    21,    22,    23,    24,    25,
     155,   155,    28,    29,   155,   155,   658,   155,     1,     1,
     155,   124,     1,     1,   155,    15,     1,     1,     3,     4,
       5,     6,     7,     8,     9,    16,   124,     1,   155,   155,
       1,   671,   672,    18,   155,    20,    21,    22,    23,    24,
      25,   155,     1,    28,    29,   685,   155,   158,   159,   160,
     161,   162,   124,     1,   124,   695,   155,     1,   169,     1,
     155,     3,     4,     5,     6,     7,     8,     9,    49,   709,
     124,   182,   682,     1,    17,    13,    18,   717,    20,   155,
       1,    23,    24,    25,     1,     1,    28,    29,     1,     1,
       1,   155,     1,   119,   120,     1,   155,     3,     4,     5,
       6,     7,     8,     9,   142,   143,   155,   155,   158,   155,
     155,   163,    18,   165,    20,   165,     1,    23,    24,    25,
       1,     1,    28,    29,    49,   124,   124,   165,   142,   143,
     124,   157,   742,   159,   119,   120,   142,   143,   164,   155,
     155,     1,   168,     3,     4,     5,     6,     7,     8,     9,
     158,   165,   155,   124,   157,   158,   182,   124,    18,   165,
      20,   124,   155,   155,    24,    25,   155,   155,    28,    29,
      49,   155,   157,   124,   159,   815,   124,   119,   120,   164,
     820,   155,   155,   168,   824,   124,   772,   142,   143,   149,
     150,   172,   173,   174,   124,   155,   155,   182,   158,   809,
     181,     1,   124,     3,     4,     5,     6,     7,     8,     9,
     165,   155,   158,   119,   120,   157,   157,   159,    18,   124,
      20,   124,   164,   124,    24,    25,   168,   155,    28,    29,
     149,   150,   151,   152,   155,   867,   868,   869,   155,   155,
     182,   827,   155,   155,   155,   155,   155,   172,   173,   174,
     124,   157,   171,   159,   124,   163,   181,   165,   164,   119,
     120,     1,   168,     3,     4,     5,     6,     7,     8,     9,
     155,   149,   150,   124,   155,   155,   182,   155,    18,   124,
      20,   867,   868,   869,    24,    25,   124,   124,    28,    29,
     876,   877,   878,   172,   173,   174,   163,   157,   165,   159,
     124,   124,   181,   124,   164,   124,   124,     1,   168,     3,
       4,     5,     6,     7,     8,     9,   160,   161,   162,   119,
     120,   124,   182,   124,    18,   169,    20,   149,   150,   124,
      24,    25,   124,   155,    28,    29,   158,   159,   124,     1,
     124,     3,     4,     5,     6,     7,     8,     9,   591,   157,
     158,   124,   160,   161,   124,   124,    18,   157,    20,   159,
     182,   169,    24,    25,   164,   124,    28,    29,   168,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   124,   119,
     120,     1,   182,     3,     4,     5,     6,     7,     8,     9,
     124,   634,   124,   636,   124,   170,   171,   124,    18,   124,
      20,   124,   124,   124,    24,    25,   149,   150,    28,    29,
     124,   124,   155,   124,   124,   124,   159,   157,   124,   159,
     124,   124,   124,   166,   164,   119,   120,     1,   168,     3,
       4,     5,     6,     7,     8,     9,   124,   124,   124,   182,
     124,   124,   182,   124,    18,   124,    20,   124,   155,     1,
      24,    25,   160,   179,    28,    29,   155,   119,   120,   155,
     155,   179,   155,   157,   155,   159,   155,   179,   183,   174,
     164,   163,    27,   155,   168,   155,   174,   155,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   182,   179,
     157,   157,   167,   158,   179,   157,   170,   159,   157,   119,
     120,   174,   164,   179,   155,     1,   168,     3,     4,     5,
       6,     7,     8,     9,   157,   170,   166,   166,   166,   166,
     182,   166,    18,   164,    20,   149,   150,   166,    24,    25,
     166,   155,    28,    29,   158,   159,   166,   157,   166,   159,
     166,   166,   163,   170,   164,   119,   120,     1,   168,     3,
       4,     5,     6,     7,     8,     9,   170,   170,   182,   170,
     179,   179,   182,   157,    18,   155,    20,   158,   157,   179,
      24,    25,   165,   185,    28,    29,   163,   165,   158,   158,
     157,    27,   167,   157,   167,   159,   167,   155,   155,   167,
     164,   167,   165,     1,   168,     3,     4,     5,     6,     7,
       8,     9,   166,   165,   179,   165,   165,   163,   182,    26,
      18,   165,    20,   163,   165,   163,    24,    25,   165,   165,
      28,    29,   165,   119,   120,     1,   170,     3,     4,     5,
       6,     7,     8,     9,   125,   126,   127,   128,   129,   130,
     131,   132,    18,   165,    20,   163,   152,   158,    24,    25,
     158,   158,    28,    29,   167,   158,    25,   167,   163,    19,
      21,   157,   166,   159,   165,   119,   120,   165,   164,   163,
     165,     1,   168,     3,     4,     5,     6,     7,     8,     9,
     164,   164,   155,   165,   165,   165,   182,   155,    18,   168,
      20,   163,   179,   179,    24,    25,   165,   163,    28,    29,
     155,   179,   163,   157,   155,   159,   158,   184,   184,    19,
     164,   119,   120,     1,   168,     3,     4,     5,     6,     7,
       8,     9,   158,   165,   155,   185,   165,   155,   182,   185,
      18,   152,    20,   155,    25,   155,    24,    25,   152,    25,
      28,    29,   186,   119,   120,   155,   186,    93,   276,   157,
     121,   159,   510,   270,   658,   822,   164,   819,   541,   709,
     168,     3,     4,     5,     6,     7,     8,     9,   663,    -1,
      -1,    -1,    -1,    -1,   182,    -1,    18,    -1,    -1,    -1,
      -1,   157,    -1,   159,    -1,    -1,    28,    29,   164,   119,
     120,    -1,   168,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    -1,    -1,   182,    -1,    18,    -1,
      20,    -1,    -1,    23,    24,    25,    -1,    -1,    28,    29,
       3,     4,     5,     6,     7,     8,     9,   157,    -1,   159,
      -1,   119,   120,    -1,   164,    18,    -1,    20,   168,    -1,
      23,    24,    25,    -1,    -1,    28,    29,    -1,    -1,    -1,
      -1,    -1,   182,    -1,   155,    -1,   157,   158,    -1,   160,
     161,     3,     4,     5,     6,     7,     8,     9,   169,   157,
      -1,   159,    -1,    -1,    -1,   151,   164,   119,   120,   180,
     168,   157,   158,    -1,   160,   161,    28,    29,    -1,    -1,
      -1,    -1,    -1,   169,   182,   144,   145,   146,   147,   148,
     149,   150,   151,   152,    -1,    -1,    -1,   149,   150,   119,
     120,   153,    -1,   155,    -1,   157,   165,   159,    -1,    -1,
      -1,    -1,   171,    -1,   166,   167,    -1,   169,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,   120,    -1,    -1,
     182,    -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,   159,
      -1,    -1,    -1,    -1,   164,    -1,    -1,   167,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   182,    18,   157,    20,   159,   119,   120,    24,
      25,   164,    -1,    28,    29,   168,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,   152,    -1,    -1,    -1,   182,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,   150,    -1,
      -1,    -1,   154,   155,   171,   157,   158,   159,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     182,    18,    -1,    20,    -1,    -1,    -1,    24,    25,    -1,
      -1,    28,    29,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    -1,    20,    -1,   119,   120,    24,    25,    -1,    -1,
      28,    29,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    -1,    20,
      -1,    -1,    23,    24,    25,    -1,    -1,    28,    29,    -1,
      -1,    -1,   157,    -1,   159,    -1,    -1,    -1,    -1,   164,
      -1,    -1,    -1,   168,     3,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,    -1,   182,    -1,    18,
      -1,    20,   119,   120,    -1,    24,    25,    -1,    -1,    28,
      29,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
      -1,   119,   120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     157,    -1,   159,    -1,    -1,    -1,    -1,   164,    -1,    -1,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,   120,
      -1,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   157,
      -1,   159,   124,    -1,    -1,    -1,   164,    -1,    -1,    -1,
     168,   133,   134,   135,   136,   137,   138,   139,   140,   141,
      -1,    -1,    -1,    -1,   182,    -1,   157,    -1,   159,    -1,
     119,   120,    -1,   164,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,
     159,     0,     1,    -1,    -1,   164,    -1,    -1,    -1,    -1,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      -1,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
      -1,    -1,   121,   122,   123,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,   178,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,    -1,
      -1,   121,   122,   123,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    44,    45,    46,    47,    48,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   121,   122,
     123,   178,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   223,   224,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,     1,   124,     1,
     124,     1,   124,     1,   124,     1,   124,     1,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,     1,   158,   124,     1,   166,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,     1,   124,     1,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,     0,     1,   192,     9,
     233,    10,   234,    11,   235,    12,   236,    13,   237,    14,
     238,    15,   239,    16,   240,    17,   241,     1,   155,     1,
     155,     1,   155,     1,   149,   150,   155,   207,     1,   155,
       1,   155,     1,   155,     1,   155,   207,     1,   155,     1,
     155,     1,   157,     1,   158,     1,   155,   157,   205,   208,
     209,   215,     1,   215,   158,     1,   157,   158,   160,   161,
     169,   180,   202,   204,   205,   208,   210,   211,   225,   226,
     227,   228,     1,   155,     1,   155,     1,   155,   155,   155,
     155,   155,   155,   155,     1,   155,     1,   155,     1,   155,
       1,   155,     1,   155,     1,   155,     1,   158,     1,   155,
       1,   158,     1,   155,     1,   207,     1,   207,     1,   155,
       1,   155,     1,   155,     1,   155,     1,   155,     1,   155,
       1,   155,     1,   155,     1,   155,     1,   158,     1,   158,
       1,   158,   158,     1,   155,     1,   157,   158,     1,   157,
     158,     1,   155,     1,   157,   158,     1,   155,     1,   155,
       1,   155,     1,   155,     1,   155,     1,   155,     1,   155,
       1,   157,     1,   157,     1,   155,     1,   155,     1,   155,
       1,   155,     1,   155,     1,   157,   202,     1,   155,     1,
     155,     1,   155,     1,   155,     1,   155,     1,   155,   157,
     155,   155,   157,   155,     1,   158,     1,   158,     1,   155,
       1,   155,     1,   157,   222,     1,   155,   155,     1,   167,
     169,     1,   169,     1,   167,   169,     1,   169,     1,   167,
       1,   167,     1,   167,     1,   169,     1,   169,   155,   155,
       1,   179,   217,   216,   179,   227,   179,   150,   177,   203,
     179,   211,   174,   163,   174,   179,   183,   174,     3,     4,
       5,     6,     7,     8,     9,    18,    20,    24,    25,    28,
      29,   119,   120,   157,   159,   164,   182,   248,   253,   257,
     259,   262,   263,   264,   265,   273,   155,   157,   158,   231,
     231,   257,   231,   231,   257,   257,   257,   231,   231,   151,
     202,    49,   172,   173,   174,   181,   213,   214,   214,     1,
     158,   219,   170,   202,     1,   157,   157,   158,   157,   167,
     155,   157,   166,   166,   166,   166,   207,   248,     1,   166,
       1,   166,     1,   166,   166,   166,   166,   166,   166,   166,
     166,   166,     1,   166,   124,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   251,   164,     1,   168,   259,     1,
     164,   170,   170,   168,   170,   170,   168,   168,   168,   163,
     170,   179,   179,   157,   202,   212,   155,   157,   214,   219,
     179,   163,   153,   166,   220,   221,   185,   165,   153,   166,
     167,   169,   207,   242,   248,   249,   250,   253,   254,   262,
     273,   165,   165,   207,   248,     1,   158,   207,     1,   158,
       1,   231,   232,   248,   242,   248,   242,   248,   158,   230,
     158,   230,   157,   272,   272,     1,   158,   163,   165,   207,
     248,   270,    27,    27,   154,   158,   166,   207,   248,   250,
     252,   273,   167,   167,   167,   167,   155,   167,   155,   180,
     206,     1,   206,   179,     1,   206,   158,   207,   166,   180,
     205,   218,     1,   163,   168,   155,   242,   242,   168,   257,
     252,   142,   143,   163,   125,   126,   127,   128,   129,   130,
     131,   132,   243,   244,   245,   246,   247,   165,   165,   165,
     165,   163,   165,   163,   165,   163,   165,   165,   165,   165,
      26,   158,   165,   158,   165,   163,   165,   165,     1,   166,
     163,   163,   165,   165,   158,   207,   248,   163,   165,   252,
     252,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     171,   257,   257,   257,   257,   170,   257,     1,   206,   165,
     165,   218,   163,   220,   152,   165,   168,   170,   242,   242,
     158,    27,   162,   225,   229,   207,   158,   248,   158,   158,
      27,   158,   207,   248,   271,   167,   256,   259,   167,    18,
      23,   164,   167,   253,   255,   260,   261,   263,   264,   265,
     273,   248,   158,   230,     1,   165,   270,   231,   231,   158,
     207,   248,   165,   252,   252,   252,   252,   252,   252,   252,
     252,   252,   252,   168,   168,   168,   168,   167,   168,   163,
     229,    25,   165,   165,   165,   163,   165,   168,   257,    19,
      21,   266,   267,   268,   166,   164,   168,   258,   260,   164,
       1,   164,   165,   165,   165,   165,   165,   163,   165,   165,
     257,   229,   163,   155,    27,   158,   207,   248,   168,   256,
     158,   207,   168,    22,   268,   269,   242,     1,   168,   260,
     255,   155,   168,   163,   206,   186,   187,   179,   179,   179,
     165,   165,   206,   163,   184,   155,   258,   258,   258,   255,
     163,   158,   155,   184,    19,   158,   165,   185,   155,   255,
     165,   155,   185,   152,   155,    25,   152,   155,    25,   186,
     155,   186
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   189,   190,   191,   191,   191,   192,   192,   193,   192,
     194,   192,   195,   192,   196,   192,   197,   192,   198,   192,
     199,   192,   200,   192,   201,   192,   192,   202,   202,   202,
     203,   203,   204,   204,   204,   205,   206,   206,   207,   207,
     207,   208,   208,   208,   208,   209,   209,   210,   210,   210,
     210,   210,   211,   211,   212,   212,   212,   213,   213,   213,
     213,   213,   214,   214,   215,   215,   216,   215,   217,   215,
     218,   218,   219,   219,   220,   220,   221,   221,   221,   222,
     222,   222,   222,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   224,   224,   224,   224,   224,   225,   225,   226,   227,
     228,   228,   229,   229,   230,   230,   231,   231,   231,   232,
     232,   233,   233,   233,   234,   234,   235,   235,   235,   236,
     236,   237,   237,   238,   238,   239,   239,   240,   240,   241,
     241,   242,   242,   242,   242,   242,   242,   243,   243,   244,
     244,   244,   244,   245,   245,   246,   246,   247,   247,   247,
     248,   248,   249,   249,   249,   249,   250,   250,   250,   250,
     250,   251,   251,   251,   251,   251,   251,   251,   251,   251,
     251,   252,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   252,   252,   252,   252,   252,   252,   252,   253,   253,
     253,   254,   254,   254,   254,   254,   255,   255,   255,   256,
     256,   256,   257,   257,   257,   258,   258,   258,   259,   259,
     259,   259,   259,   259,   259,   259,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   261,   261,   262,   262,   263,
     264,   265,   266,   266,   267,   267,   268,   268,   268,   268,
     269,   269,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   271,   271,   271,   271,   271,   271,   271,
     271,   272,   272,   272,   272,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     1,     2,
       2,     3,     5,     5,     2,     3,     5,     1,     3,     5,
       5,     1,     1,     2,     1,     3,     3,     1,     2,     2,
       2,     2,     1,     2,     1,     1,     0,     3,     0,     3,
       1,     1,     1,     2,     9,    10,     3,     1,     2,    18,
      17,    10,     9,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     3,     3,     3,     3,     5,
       3,     3,     5,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     5,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     5,
       5,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,     2,     7,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     2,     8,     8,     2,     1,     1,     1,     1,
       1,     3,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     4,     7,     2,     7,     2,     4,     7,     2,     7,
       2,     4,     2,     4,     2,     4,     2,     9,     2,     7,
       2,     3,     3,     2,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     3,     3,
       3,     1,     1,     1,     3,     2,     1,     3,     2,     1,
       3,     2,     2,     1,     2,     2,     1,     2,     2,     1,
       1,     1,     1,     2,     1,     2,     2,     2,     1,     1,
       1,     1,     2,     1,     2,     5,     7,     5,     7,     5,
       7,     7,     2,     1,     2,     1,     4,     3,     4,     3,
       3,     2,     1,     3,     1,     2,     2,     1,     2,     3,
       1,     2,     3,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     4,     4,     2,     6,     1,     3,     1,     3,
       2,     4,     2,     4,     3,     1,     4,     6,     2,     4,
       6,     2,     4,     4,     6,     2,     4,     3,     4,     4,
       2,     4,     4,     4,     4,     6,     6,     6,     8,     6,
       4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* statements: statements statement  */
#line 484 "cfg.y"
                                     {}
#line 2403 "cfg.tab.c"
    break;

  case 4: /* statements: statement  */
#line 485 "cfg.y"
                            {}
#line 2409 "cfg.tab.c"
    break;

  case 5: /* statements: statements error  */
#line 486 "cfg.y"
                                   { yyerror(""); YYABORT;}
#line 2415 "cfg.tab.c"
    break;

  case 8: /* $@1: %empty  */
#line 491 "cfg.y"
                  {rt=REQUEST_ROUTE;}
#line 2421 "cfg.tab.c"
    break;

  case 10: /* $@2: %empty  */
#line 492 "cfg.y"
                  {rt=FAILURE_ROUTE;}
#line 2427 "cfg.tab.c"
    break;

  case 12: /* $@3: %empty  */
#line 493 "cfg.y"
                  {rt=ONREPLY_ROUTE;}
#line 2433 "cfg.tab.c"
    break;

  case 14: /* $@4: %empty  */
#line 494 "cfg.y"
                  {rt=BRANCH_ROUTE;}
#line 2439 "cfg.tab.c"
    break;

  case 16: /* $@5: %empty  */
#line 495 "cfg.y"
                  {rt=ERROR_ROUTE;}
#line 2445 "cfg.tab.c"
    break;

  case 18: /* $@6: %empty  */
#line 496 "cfg.y"
                  {rt=LOCAL_ROUTE;}
#line 2451 "cfg.tab.c"
    break;

  case 20: /* $@7: %empty  */
#line 497 "cfg.y"
                  {rt=STARTUP_ROUTE;}
#line 2457 "cfg.tab.c"
    break;

  case 22: /* $@8: %empty  */
#line 498 "cfg.y"
                  {rt=TIMER_ROUTE;}
#line 2463 "cfg.tab.c"
    break;

  case 24: /* $@9: %empty  */
#line 499 "cfg.y"
                  {rt=EVENT_ROUTE;}
#line 2469 "cfg.tab.c"
    break;

  case 27: /* listen_id: ip  */
#line 504 "cfg.y"
                                        { IFOR();
							tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 2489 "cfg.tab.c"
    break;

  case 28: /* listen_id: STRING  */
#line 519 "cfg.y"
                                        { IFOR();
							(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 2503 "cfg.tab.c"
    break;

  case 29: /* listen_id: host  */
#line 528 "cfg.y"
                                        { IFOR();
							if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 2521 "cfg.tab.c"
    break;

  case 30: /* host_sep: DOT  */
#line 543 "cfg.y"
                    {(yyval.strval)=".";}
#line 2527 "cfg.tab.c"
    break;

  case 31: /* host_sep: MINUS  */
#line 544 "cfg.y"
                              {(yyval.strval)="-"; }
#line 2533 "cfg.tab.c"
    break;

  case 32: /* host: ID  */
#line 547 "cfg.y"
                                        { (yyval.strval)=(yyvsp[0].strval); }
#line 2539 "cfg.tab.c"
    break;

  case 33: /* host: host host_sep ID  */
#line 548 "cfg.y"
                                { IFOR();
						(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						}else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						}
						pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
					}
#line 2558 "cfg.tab.c"
    break;

  case 34: /* host: host DOT error  */
#line 562 "cfg.y"
                         { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
					yyerror("invalid hostname (use quotes if hostname "
						"has config keywords)"); }
#line 2566 "cfg.tab.c"
    break;

  case 35: /* proto: ID  */
#line 567 "cfg.y"
           { IFOR();
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		pkg_free((yyvsp[0].strval));
		(yyval.intval) = i_tmp;
	 }
#line 2579 "cfg.tab.c"
    break;

  case 36: /* port: NUMBER  */
#line 577 "cfg.y"
                        { (yyval.intval)=(yyvsp[0].intval); }
#line 2585 "cfg.tab.c"
    break;

  case 37: /* port: ANY  */
#line 578 "cfg.y"
                                { (yyval.intval)=0; }
#line 2591 "cfg.tab.c"
    break;

  case 38: /* snumber: NUMBER  */
#line 581 "cfg.y"
                        { (yyval.intval)=(yyvsp[0].intval); }
#line 2597 "cfg.tab.c"
    break;

  case 39: /* snumber: PLUS NUMBER  */
#line 582 "cfg.y"
                                { (yyval.intval)=(yyvsp[0].intval); }
#line 2603 "cfg.tab.c"
    break;

  case 40: /* snumber: MINUS NUMBER  */
#line 583 "cfg.y"
                                { (yyval.intval)=-(yyvsp[0].intval); }
#line 2609 "cfg.tab.c"
    break;

  case 41: /* phostport: proto COLON listen_id  */
#line 587 "cfg.y"
                                        { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2616 "cfg.tab.c"
    break;

  case 42: /* phostport: proto COLON listen_id COLON port  */
#line 589 "cfg.y"
                                                                { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 2623 "cfg.tab.c"
    break;

  case 43: /* phostport: proto COLON listen_id COLON error  */
#line 591 "cfg.y"
                                                            {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 2633 "cfg.tab.c"
    break;

  case 44: /* phostport: NUMBER error  */
#line 596 "cfg.y"
                                       { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 2642 "cfg.tab.c"
    break;

  case 45: /* panyhostport: proto COLON MULT  */
#line 602 "cfg.y"
                                                        { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 2649 "cfg.tab.c"
    break;

  case 46: /* panyhostport: proto COLON MULT COLON port  */
#line 604 "cfg.y"
                                                        { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-4].intval), (yyvsp[0].intval)); }
#line 2656 "cfg.tab.c"
    break;

  case 47: /* alias_def: listen_id  */
#line 608 "cfg.y"
                                                                        { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2663 "cfg.tab.c"
    break;

  case 48: /* alias_def: ANY COLON listen_id  */
#line 610 "cfg.y"
                                                                        { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2670 "cfg.tab.c"
    break;

  case 49: /* alias_def: ANY COLON listen_id COLON port  */
#line 612 "cfg.y"
                                                        { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2677 "cfg.tab.c"
    break;

  case 50: /* alias_def: ANY COLON listen_id COLON error  */
#line 614 "cfg.y"
                                                        {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 2686 "cfg.tab.c"
    break;

  case 52: /* id_lst: alias_def  */
#line 621 "cfg.y"
                                        { IFOR();  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 2692 "cfg.tab.c"
    break;

  case 53: /* id_lst: alias_def id_lst  */
#line 622 "cfg.y"
                                        { IFOR(); (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 2698 "cfg.tab.c"
    break;

  case 54: /* listen_id_def: listen_id  */
#line 625 "cfg.y"
                                                                { IFOR();
					(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2705 "cfg.tab.c"
    break;

  case 55: /* listen_id_def: listen_id COLON port  */
#line 627 "cfg.y"
                                                                { IFOR();
			 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2712 "cfg.tab.c"
    break;

  case 56: /* listen_id_def: listen_id COLON error  */
#line 629 "cfg.y"
                                                      {
					(yyval.sockid)=0;
					yyerror(" port number expected");
					}
#line 2721 "cfg.tab.c"
    break;

  case 57: /* socket_def_param: ANYCAST  */
#line 635 "cfg.y"
                          { IFOR();
					p_tmp.flags |= SI_IS_ANYCAST;
					}
#line 2729 "cfg.tab.c"
    break;

  case 58: /* socket_def_param: USE_WORKERS NUMBER  */
#line 638 "cfg.y"
                                                     { IFOR();
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 2737 "cfg.tab.c"
    break;

  case 59: /* socket_def_param: AS listen_id_def  */
#line 641 "cfg.y"
                                                   { IFOR();
					p_tmp.socket = (yyvsp[0].sockid);
					}
#line 2745 "cfg.tab.c"
    break;

  case 60: /* socket_def_param: TAG ID  */
#line 644 "cfg.y"
                                         { IFOR();
					p_tmp.tag = (yyvsp[0].strval);
					}
#line 2753 "cfg.tab.c"
    break;

  case 61: /* socket_def_param: USE_AUTO_SCALING_PROFILE ID  */
#line 647 "cfg.y"
                                                              { IFOR();
					p_tmp.auto_scaling_profile=(yyvsp[0].strval);
					}
#line 2761 "cfg.tab.c"
    break;

  case 64: /* socket_def: panyhostport  */
#line 656 "cfg.y"
                                                { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2767 "cfg.tab.c"
    break;

  case 65: /* socket_def: phostport  */
#line 657 "cfg.y"
                                                                { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2773 "cfg.tab.c"
    break;

  case 66: /* $@10: %empty  */
#line 658 "cfg.y"
                                       { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2781 "cfg.tab.c"
    break;

  case 67: /* socket_def: panyhostport $@10 socket_def_params  */
#line 660 "cfg.y"
                                                        { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2789 "cfg.tab.c"
    break;

  case 68: /* $@11: %empty  */
#line 663 "cfg.y"
                                    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2797 "cfg.tab.c"
    break;

  case 69: /* socket_def: phostport $@11 socket_def_params  */
#line 665 "cfg.y"
                                                        { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2805 "cfg.tab.c"
    break;

  case 70: /* any_proto: ANY  */
#line 670 "cfg.y"
                        { (yyval.intval)=PROTO_NONE; }
#line 2811 "cfg.tab.c"
    break;

  case 71: /* any_proto: proto  */
#line 671 "cfg.y"
                                { (yyval.intval)=(yyvsp[0].intval); }
#line 2817 "cfg.tab.c"
    break;

  case 72: /* multi_string: STRING  */
#line 673 "cfg.y"
                       {  IFOR(); (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 2823 "cfg.tab.c"
    break;

  case 73: /* multi_string: STRING multi_string  */
#line 674 "cfg.y"
                                      { IFOR(); (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 2829 "cfg.tab.c"
    break;

  case 74: /* blst_elem: LPAREN any_proto COMMA ipnet COMMA port COMMA STRING RPAREN  */
#line 677 "cfg.y"
                                                                        {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2842 "cfg.tab.c"
    break;

  case 75: /* blst_elem: NOT LPAREN any_proto COMMA ipnet COMMA port COMMA STRING RPAREN  */
#line 685 "cfg.y"
                                                                                    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2856 "cfg.tab.c"
    break;

  case 76: /* blst_elem_list: blst_elem_list COMMA blst_elem  */
#line 696 "cfg.y"
                                               {}
#line 2862 "cfg.tab.c"
    break;

  case 77: /* blst_elem_list: blst_elem  */
#line 697 "cfg.y"
                            {}
#line 2868 "cfg.tab.c"
    break;

  case 78: /* blst_elem_list: blst_elem_list error  */
#line 698 "cfg.y"
                                       { yyerror("bad black list element");}
#line 2874 "cfg.tab.c"
    break;

  case 79: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES_WITHIN NUMBER SCALE_DOWN_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 705 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-17].strval),(yyvsp[-15].intval),(yyvsp[-13].intval),(yyvsp[-10].intval),(yyvsp[-8].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval),10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 2884 "cfg.tab.c"
    break;

  case 80: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES SCALE_DOWN_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 713 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-16].strval),(yyvsp[-14].intval),(yyvsp[-12].intval),(yyvsp[-9].intval),(yyvsp[-9].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval), 10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 2894 "cfg.tab.c"
    break;

  case 81: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES_WITHIN NUMBER  */
#line 719 "cfg.y"
                                                            { IFOR();
			if (create_auto_scaling_profile((yyvsp[-9].strval),(yyvsp[-7].intval),(yyvsp[-5].intval),(yyvsp[-2].intval),(yyvsp[0].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 2904 "cfg.tab.c"
    break;

  case 82: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 725 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-8].strval),(yyvsp[-6].intval),(yyvsp[-4].intval),(yyvsp[-1].intval),(yyvsp[-1].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 2914 "cfg.tab.c"
    break;

  case 83: /* assign_stm: LOGLEVEL EQUAL snumber  */
#line 732 "cfg.y"
                                   { IFOR();
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 2923 "cfg.tab.c"
    break;

  case 84: /* assign_stm: ENABLE_ASSERTS EQUAL NUMBER  */
#line 736 "cfg.y"
                                               { IFOR(); enable_asserts=(yyvsp[0].intval); }
#line 2929 "cfg.tab.c"
    break;

  case 85: /* assign_stm: ENABLE_ASSERTS EQUAL error  */
#line 737 "cfg.y"
                                              { yyerror("boolean value expected"); }
#line 2935 "cfg.tab.c"
    break;

  case 86: /* assign_stm: ABORT_ON_ASSERT EQUAL NUMBER  */
#line 738 "cfg.y"
                                                { IFOR(); abort_on_assert=(yyvsp[0].intval); }
#line 2941 "cfg.tab.c"
    break;

  case 87: /* assign_stm: ABORT_ON_ASSERT EQUAL error  */
#line 739 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 2947 "cfg.tab.c"
    break;

  case 88: /* assign_stm: DEBUG_MODE EQUAL NUMBER  */
#line 740 "cfg.y"
                                           { IFOR();
			debug_mode=(yyvsp[0].intval);
			if (debug_mode) { *log_level = L_DBG;log_stderr=1;}
			}
#line 2956 "cfg.tab.c"
    break;

  case 89: /* assign_stm: DEBUG_MODE EQUAL error  */
#line 745 "cfg.y"
                        { yyerror("boolean value expected for debug_mode"); }
#line 2962 "cfg.tab.c"
    break;

  case 90: /* assign_stm: LOGSTDOUT EQUAL NUMBER  */
#line 748 "cfg.y"
                        { IFOR(); log_stdout=(yyvsp[0].intval); }
#line 2968 "cfg.tab.c"
    break;

  case 91: /* assign_stm: LOGSTDOUT EQUAL error  */
#line 749 "cfg.y"
                                        { yyerror("boolean value expected"); }
#line 2974 "cfg.tab.c"
    break;

  case 92: /* assign_stm: LOGSTDERROR EQUAL NUMBER  */
#line 753 "cfg.y"
                        { IFOR(); if (!config_check && !debug_mode) log_stderr=(yyvsp[0].intval); }
#line 2980 "cfg.tab.c"
    break;

  case 93: /* assign_stm: LOGSTDERROR EQUAL error  */
#line 754 "cfg.y"
                                          { yyerror("boolean value expected"); }
#line 2986 "cfg.tab.c"
    break;

  case 94: /* assign_stm: LOGFACILITY EQUAL ID  */
#line 755 "cfg.y"
                                       { IFOR();
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 2997 "cfg.tab.c"
    break;

  case 95: /* assign_stm: LOGFACILITY EQUAL error  */
#line 761 "cfg.y"
                                          { yyerror("ID expected"); }
#line 3003 "cfg.tab.c"
    break;

  case 96: /* assign_stm: LOGNAME EQUAL STRING  */
#line 762 "cfg.y"
                                       { IFOR(); log_name=(yyvsp[0].strval); }
#line 3009 "cfg.tab.c"
    break;

  case 97: /* assign_stm: LOGNAME EQUAL error  */
#line 763 "cfg.y"
                                      { yyerror("string value expected"); }
#line 3015 "cfg.tab.c"
    break;

  case 98: /* assign_stm: DNS EQUAL NUMBER  */
#line 764 "cfg.y"
                                     { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 3021 "cfg.tab.c"
    break;

  case 99: /* assign_stm: DNS EQUAL error  */
#line 765 "cfg.y"
                                  { yyerror("boolean value expected"); }
#line 3027 "cfg.tab.c"
    break;

  case 100: /* assign_stm: REV_DNS EQUAL NUMBER  */
#line 766 "cfg.y"
                                       { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 3033 "cfg.tab.c"
    break;

  case 101: /* assign_stm: REV_DNS EQUAL error  */
#line 767 "cfg.y"
                                      { yyerror("boolean value expected"); }
#line 3039 "cfg.tab.c"
    break;

  case 102: /* assign_stm: DNS_TRY_IPV6 EQUAL NUMBER  */
#line 768 "cfg.y"
                                              { IFOR(); dns_try_ipv6=(yyvsp[0].intval); }
#line 3045 "cfg.tab.c"
    break;

  case 103: /* assign_stm: DNS_TRY_IPV6 error  */
#line 769 "cfg.y"
                                     { yyerror("boolean value expected"); }
#line 3051 "cfg.tab.c"
    break;

  case 104: /* assign_stm: DNS_TRY_NAPTR EQUAL NUMBER  */
#line 770 "cfg.y"
                                               { IFOR(); dns_try_naptr=(yyvsp[0].intval); }
#line 3057 "cfg.tab.c"
    break;

  case 105: /* assign_stm: DNS_TRY_NAPTR error  */
#line 771 "cfg.y"
                                      { yyerror("boolean value expected"); }
#line 3063 "cfg.tab.c"
    break;

  case 106: /* assign_stm: DNS_RETR_TIME EQUAL NUMBER  */
#line 772 "cfg.y"
                                               { IFOR(); dns_retr_time=(yyvsp[0].intval); }
#line 3069 "cfg.tab.c"
    break;

  case 107: /* assign_stm: DNS_RETR_TIME error  */
#line 773 "cfg.y"
                                      { yyerror("number expected"); }
#line 3075 "cfg.tab.c"
    break;

  case 108: /* assign_stm: DNS_RETR_NO EQUAL NUMBER  */
#line 774 "cfg.y"
                                             { IFOR(); dns_retr_no=(yyvsp[0].intval); }
#line 3081 "cfg.tab.c"
    break;

  case 109: /* assign_stm: DNS_RETR_NO error  */
#line 775 "cfg.y"
                                    { yyerror("number expected"); }
#line 3087 "cfg.tab.c"
    break;

  case 110: /* assign_stm: DNS_SERVERS_NO EQUAL NUMBER  */
#line 776 "cfg.y"
                                                { IFOR(); dns_servers_no=(yyvsp[0].intval); }
#line 3093 "cfg.tab.c"
    break;

  case 111: /* assign_stm: DNS_SERVERS_NO error  */
#line 777 "cfg.y"
                                       { yyerror("number expected"); }
#line 3099 "cfg.tab.c"
    break;

  case 112: /* assign_stm: DNS_USE_SEARCH EQUAL NUMBER  */
#line 778 "cfg.y"
                                                { IFOR(); dns_search_list=(yyvsp[0].intval); }
#line 3105 "cfg.tab.c"
    break;

  case 113: /* assign_stm: DNS_USE_SEARCH error  */
#line 779 "cfg.y"
                                       { yyerror("boolean value expected"); }
#line 3111 "cfg.tab.c"
    break;

  case 114: /* assign_stm: MAX_WHILE_LOOPS EQUAL NUMBER  */
#line 780 "cfg.y"
                                               { IFOR(); max_while_loops=(yyvsp[0].intval); }
#line 3117 "cfg.tab.c"
    break;

  case 115: /* assign_stm: MAX_WHILE_LOOPS EQUAL error  */
#line 781 "cfg.y"
                                              { yyerror("number expected"); }
#line 3123 "cfg.tab.c"
    break;

  case 116: /* assign_stm: MAXBUFFER EQUAL NUMBER  */
#line 782 "cfg.y"
                                         { IFOR(); maxbuffer=(yyvsp[0].intval); }
#line 3129 "cfg.tab.c"
    break;

  case 117: /* assign_stm: MAXBUFFER EQUAL error  */
#line 783 "cfg.y"
                                        { yyerror("number expected"); }
#line 3135 "cfg.tab.c"
    break;

  case 118: /* assign_stm: UDP_WORKERS EQUAL NUMBER  */
#line 784 "cfg.y"
                                           { IFOR(); udp_workers_no=(yyvsp[0].intval); }
#line 3141 "cfg.tab.c"
    break;

  case 119: /* assign_stm: UDP_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 785 "cfg.y"
                                                                       { IFOR();
				udp_workers_no=(yyvsp[-2].intval);
				udp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3150 "cfg.tab.c"
    break;

  case 120: /* assign_stm: UDP_WORKERS EQUAL error  */
#line 789 "cfg.y"
                                          { yyerror("number expected"); }
#line 3156 "cfg.tab.c"
    break;

  case 121: /* assign_stm: TIMER_WORKERS EQUAL NUMBER  */
#line 790 "cfg.y"
                                             { IFOR();
				timer_workers_no=(yyvsp[0].intval);
		}
#line 3164 "cfg.tab.c"
    break;

  case 122: /* assign_stm: TIMER_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 793 "cfg.y"
                                                                         { IFOR();
				timer_workers_no=(yyvsp[-2].intval);
				timer_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3173 "cfg.tab.c"
    break;

  case 123: /* assign_stm: CHECK_VIA EQUAL NUMBER  */
#line 797 "cfg.y"
                                         { check_via=(yyvsp[0].intval); }
#line 3179 "cfg.tab.c"
    break;

  case 124: /* assign_stm: CHECK_VIA EQUAL error  */
#line 798 "cfg.y"
                                        { yyerror("boolean value expected"); }
#line 3185 "cfg.tab.c"
    break;

  case 125: /* assign_stm: SHM_HASH_SPLIT_PERCENTAGE EQUAL NUMBER  */
#line 799 "cfg.y"
                                                         { IFOR();
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3198 "cfg.tab.c"
    break;

  case 126: /* assign_stm: SHM_HASH_SPLIT_PERCENTAGE EQUAL error  */
#line 807 "cfg.y"
                                                        {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 3211 "cfg.tab.c"
    break;

  case 127: /* assign_stm: SHM_SECONDARY_HASH_SIZE EQUAL NUMBER  */
#line 815 "cfg.y"
                                                       { IFOR();
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3224 "cfg.tab.c"
    break;

  case 128: /* assign_stm: SHM_SECONDARY_HASH_SIZE EQUAL error  */
#line 823 "cfg.y"
                                                      {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3237 "cfg.tab.c"
    break;

  case 129: /* assign_stm: MEM_WARMING_ENABLED EQUAL NUMBER  */
#line 831 "cfg.y"
                                                   { IFOR();
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3250 "cfg.tab.c"
    break;

  case 130: /* assign_stm: MEM_WARMING_ENABLED EQUAL error  */
#line 839 "cfg.y"
                                                  {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3263 "cfg.tab.c"
    break;

  case 131: /* assign_stm: MEM_WARMING_PATTERN_FILE EQUAL STRING  */
#line 847 "cfg.y"
                                                        { IFOR();
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3276 "cfg.tab.c"
    break;

  case 132: /* assign_stm: MEM_WARMING_PATTERN_FILE EQUAL error  */
#line 855 "cfg.y"
                                                       {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3289 "cfg.tab.c"
    break;

  case 133: /* assign_stm: MEM_WARMING_PERCENTAGE EQUAL NUMBER  */
#line 863 "cfg.y"
                                                      { IFOR();
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3302 "cfg.tab.c"
    break;

  case 134: /* assign_stm: MEM_WARMING_PERCENTAGE EQUAL error  */
#line 871 "cfg.y"
                                                     {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3315 "cfg.tab.c"
    break;

  case 135: /* assign_stm: RPM_MEM_FILE EQUAL STRING  */
#line 879 "cfg.y"
                                            { IFOR();
			rpm_mem_file = (yyvsp[0].strval);
			}
#line 3323 "cfg.tab.c"
    break;

  case 136: /* assign_stm: RPM_MEM_FILE EQUAL error  */
#line 882 "cfg.y"
                                           { yyerror("string value expected"); }
#line 3329 "cfg.tab.c"
    break;

  case 137: /* assign_stm: RPM_MEM_SIZE EQUAL NUMBER  */
#line 883 "cfg.y"
                                            { IFOR();
			rpm_mem_size = (yyvsp[0].intval) * 1024 * 1024;
			}
#line 3337 "cfg.tab.c"
    break;

  case 138: /* assign_stm: RPM_MEM_SIZE EQUAL error  */
#line 886 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3343 "cfg.tab.c"
    break;

  case 139: /* assign_stm: MEMLOG EQUAL snumber  */
#line 887 "cfg.y"
                                       { IFOR(); memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 3349 "cfg.tab.c"
    break;

  case 140: /* assign_stm: MEMLOG EQUAL error  */
#line 888 "cfg.y"
                                     { yyerror("int value expected"); }
#line 3355 "cfg.tab.c"
    break;

  case 141: /* assign_stm: MEMDUMP EQUAL snumber  */
#line 889 "cfg.y"
                                        { IFOR(); memdump=(yyvsp[0].intval); }
#line 3361 "cfg.tab.c"
    break;

  case 142: /* assign_stm: MEMDUMP EQUAL error  */
#line 890 "cfg.y"
                                      { yyerror("int value expected"); }
#line 3367 "cfg.tab.c"
    break;

  case 143: /* assign_stm: EXECMSGTHRESHOLD EQUAL NUMBER  */
#line 891 "cfg.y"
                                                {  IFOR();execmsgthreshold=(yyvsp[0].intval); }
#line 3373 "cfg.tab.c"
    break;

  case 144: /* assign_stm: EXECMSGTHRESHOLD EQUAL error  */
#line 892 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3379 "cfg.tab.c"
    break;

  case 145: /* assign_stm: EXECDNSTHRESHOLD EQUAL NUMBER  */
#line 893 "cfg.y"
                                                { IFOR(); execdnsthreshold=(yyvsp[0].intval); }
#line 3385 "cfg.tab.c"
    break;

  case 146: /* assign_stm: EXECDNSTHRESHOLD EQUAL error  */
#line 894 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3391 "cfg.tab.c"
    break;

  case 147: /* assign_stm: TCPTHRESHOLD EQUAL NUMBER  */
#line 895 "cfg.y"
                                            { IFOR(); tcpthreshold=(yyvsp[0].intval); }
#line 3397 "cfg.tab.c"
    break;

  case 148: /* assign_stm: TCPTHRESHOLD EQUAL error  */
#line 896 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3403 "cfg.tab.c"
    break;

  case 149: /* assign_stm: EVENT_SHM_THRESHOLD EQUAL NUMBER  */
#line 897 "cfg.y"
                                                   { IFOR();
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 3418 "cfg.tab.c"
    break;

  case 150: /* assign_stm: EVENT_SHM_THRESHOLD EQUAL error  */
#line 907 "cfg.y"
                                                  { yyerror("int value expected"); }
#line 3424 "cfg.tab.c"
    break;

  case 151: /* assign_stm: EVENT_PKG_THRESHOLD EQUAL NUMBER  */
#line 908 "cfg.y"
                                                   { IFOR();
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 3443 "cfg.tab.c"
    break;

  case 152: /* assign_stm: EVENT_PKG_THRESHOLD EQUAL error  */
#line 922 "cfg.y"
                                                  { yyerror("int value expected"); }
#line 3449 "cfg.tab.c"
    break;

  case 153: /* assign_stm: QUERYBUFFERSIZE EQUAL NUMBER  */
#line 923 "cfg.y"
                                               { IFOR(); query_buffer_size=(yyvsp[0].intval); }
#line 3455 "cfg.tab.c"
    break;

  case 154: /* assign_stm: QUERYBUFFERSIZE EQUAL error  */
#line 924 "cfg.y"
                                              { yyerror("int value expected"); }
#line 3461 "cfg.tab.c"
    break;

  case 155: /* assign_stm: QUERYFLUSHTIME EQUAL NUMBER  */
#line 925 "cfg.y"
                                              { IFOR(); query_flush_time=(yyvsp[0].intval); }
#line 3467 "cfg.tab.c"
    break;

  case 156: /* assign_stm: QUERYFLUSHTIME EQUAL error  */
#line 926 "cfg.y"
                                             { yyerror("int value expected"); }
#line 3473 "cfg.tab.c"
    break;

  case 157: /* assign_stm: SIP_WARNING EQUAL NUMBER  */
#line 927 "cfg.y"
                                           { IFOR(); sip_warning=(yyvsp[0].intval); }
#line 3479 "cfg.tab.c"
    break;

  case 158: /* assign_stm: SIP_WARNING EQUAL error  */
#line 928 "cfg.y"
                                          { yyerror("boolean value expected"); }
#line 3485 "cfg.tab.c"
    break;

  case 159: /* assign_stm: CHROOT EQUAL STRING  */
#line 929 "cfg.y"
                                          { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 3491 "cfg.tab.c"
    break;

  case 160: /* assign_stm: CHROOT EQUAL ID  */
#line 930 "cfg.y"
                                          { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 3497 "cfg.tab.c"
    break;

  case 161: /* assign_stm: CHROOT EQUAL error  */
#line 931 "cfg.y"
                                          { yyerror("string value expected"); }
#line 3503 "cfg.tab.c"
    break;

  case 162: /* assign_stm: WDIR EQUAL STRING  */
#line 932 "cfg.y"
                                        { IFOR(); working_dir=(yyvsp[0].strval); }
#line 3509 "cfg.tab.c"
    break;

  case 163: /* assign_stm: WDIR EQUAL ID  */
#line 933 "cfg.y"
                                        { IFOR(); working_dir=(yyvsp[0].strval); }
#line 3515 "cfg.tab.c"
    break;

  case 164: /* assign_stm: WDIR EQUAL error  */
#line 934 "cfg.y"
                                        { yyerror("string value expected"); }
#line 3521 "cfg.tab.c"
    break;

  case 165: /* assign_stm: MHOMED EQUAL NUMBER  */
#line 935 "cfg.y"
                                      { IFOR(); mhomed=(yyvsp[0].intval); }
#line 3527 "cfg.tab.c"
    break;

  case 166: /* assign_stm: MHOMED EQUAL error  */
#line 936 "cfg.y"
                                     { yyerror("boolean value expected"); }
#line 3533 "cfg.tab.c"
    break;

  case 167: /* assign_stm: POLL_METHOD EQUAL ID  */
#line 937 "cfg.y"
                                       { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 3548 "cfg.tab.c"
    break;

  case 168: /* assign_stm: POLL_METHOD EQUAL STRING  */
#line 947 "cfg.y"
                                           { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 3563 "cfg.tab.c"
    break;

  case 169: /* assign_stm: POLL_METHOD EQUAL error  */
#line 957 "cfg.y"
                                          { yyerror("poll method name expected"); }
#line 3569 "cfg.tab.c"
    break;

  case 170: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL NUMBER  */
#line 958 "cfg.y"
                                                  { IFOR();
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 3577 "cfg.tab.c"
    break;

  case 171: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL error  */
#line 961 "cfg.y"
                                                 { yyerror("boolean value expected"); }
#line 3583 "cfg.tab.c"
    break;

  case 172: /* assign_stm: TCP_WORKERS EQUAL NUMBER  */
#line 962 "cfg.y"
                                           { IFOR();
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 3591 "cfg.tab.c"
    break;

  case 173: /* assign_stm: TCP_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 965 "cfg.y"
                                                                      { IFOR();
				tcp_workers_no=(yyvsp[-2].intval);
				tcp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3600 "cfg.tab.c"
    break;

  case 174: /* assign_stm: TCP_WORKERS EQUAL error  */
#line 969 "cfg.y"
                                          { yyerror("number expected"); }
#line 3606 "cfg.tab.c"
    break;

  case 175: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL NUMBER  */
#line 970 "cfg.y"
                                                   { IFOR();
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 3614 "cfg.tab.c"
    break;

  case 176: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL error  */
#line 973 "cfg.y"
                                                  { yyerror("number expected"); }
#line 3620 "cfg.tab.c"
    break;

  case 177: /* assign_stm: TCP_CON_LIFETIME EQUAL NUMBER  */
#line 974 "cfg.y"
                                                { IFOR();
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 3628 "cfg.tab.c"
    break;

  case 178: /* assign_stm: TCP_CON_LIFETIME EQUAL error  */
#line 977 "cfg.y"
                                               { yyerror("number expected"); }
#line 3634 "cfg.tab.c"
    break;

  case 179: /* assign_stm: TCP_LISTEN_BACKLOG EQUAL NUMBER  */
#line 978 "cfg.y"
                                                  { IFOR();
				warn("tcp_listen_backlog is deprecated, use tcp_socket_backlog");
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 3643 "cfg.tab.c"
    break;

  case 180: /* assign_stm: TCP_LISTEN_BACKLOG EQUAL error  */
#line 982 "cfg.y"
                                                 { yyerror("number expected"); }
#line 3649 "cfg.tab.c"
    break;

  case 181: /* assign_stm: TCP_SOCKET_BACKLOG EQUAL NUMBER  */
#line 983 "cfg.y"
                                                  { IFOR();
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 3657 "cfg.tab.c"
    break;

  case 182: /* assign_stm: TCP_SOCKET_BACKLOG EQUAL error  */
#line 986 "cfg.y"
                                                 { yyerror("number expected"); }
#line 3663 "cfg.tab.c"
    break;

  case 183: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL NUMBER  */
#line 987 "cfg.y"
                                                   { IFOR();
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 3671 "cfg.tab.c"
    break;

  case 184: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL error  */
#line 990 "cfg.y"
                                                  { yyerror("number expected"); }
#line 3677 "cfg.tab.c"
    break;

  case 185: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL ID  */
#line 991 "cfg.y"
                                                 { IFOR();
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 3689 "cfg.tab.c"
    break;

  case 186: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL error  */
#line 998 "cfg.y"
                                                    { yyerror("number value expected"); }
#line 3695 "cfg.tab.c"
    break;

  case 187: /* assign_stm: TCP_NO_NEW_CONN_RPLFLAG EQUAL ID  */
#line 999 "cfg.y"
                                                   { IFOR();
				tcp_no_new_conn_rplflag =
					get_flag_id_by_name(FLAG_TYPE_MSG, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_rplflag ) )
					yyerror("invalid TCP no_new_conn RePLy Flag");
				flag_idx2mask( &tcp_no_new_conn_rplflag );
		}
#line 3707 "cfg.tab.c"
    break;

  case 188: /* assign_stm: TCP_NO_NEW_CONN_RPLFLAG EQUAL error  */
#line 1006 "cfg.y"
                                                      { yyerror("number value expected"); }
#line 3713 "cfg.tab.c"
    break;

  case 189: /* assign_stm: TCP_KEEPALIVE EQUAL NUMBER  */
#line 1008 "cfg.y"
                                             { IFOR();
				tcp_keepalive=(yyvsp[0].intval);
		}
#line 3721 "cfg.tab.c"
    break;

  case 190: /* assign_stm: TCP_KEEPALIVE EQUAL error  */
#line 1011 "cfg.y"
                                            { yyerror("boolean value expected"); }
#line 3727 "cfg.tab.c"
    break;

  case 191: /* assign_stm: TCP_MAX_MSG_TIME EQUAL NUMBER  */
#line 1012 "cfg.y"
                                                { IFOR();
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 3735 "cfg.tab.c"
    break;

  case 192: /* assign_stm: TCP_MAX_MSG_TIME EQUAL error  */
#line 1015 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3741 "cfg.tab.c"
    break;

  case 193: /* assign_stm: TCP_KEEPCOUNT EQUAL NUMBER  */
#line 1016 "cfg.y"
                                                        { IFOR();
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 3753 "cfg.tab.c"
    break;

  case 194: /* assign_stm: TCP_KEEPCOUNT EQUAL error  */
#line 1023 "cfg.y"
                                            { yyerror("int value expected"); }
#line 3759 "cfg.tab.c"
    break;

  case 195: /* assign_stm: TCP_KEEPIDLE EQUAL NUMBER  */
#line 1024 "cfg.y"
                                                        { IFOR();
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 3771 "cfg.tab.c"
    break;

  case 196: /* assign_stm: TCP_KEEPIDLE EQUAL error  */
#line 1031 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3777 "cfg.tab.c"
    break;

  case 197: /* assign_stm: TCP_KEEPINTERVAL EQUAL NUMBER  */
#line 1032 "cfg.y"
                                                { IFOR();
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 3789 "cfg.tab.c"
    break;

  case 198: /* assign_stm: TCP_KEEPINTERVAL EQUAL error  */
#line 1039 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3795 "cfg.tab.c"
    break;

  case 199: /* assign_stm: SERVER_SIGNATURE EQUAL NUMBER  */
#line 1040 "cfg.y"
                                                { IFOR();
							server_signature=(yyvsp[0].intval); }
#line 3802 "cfg.tab.c"
    break;

  case 200: /* assign_stm: SERVER_SIGNATURE EQUAL error  */
#line 1042 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3808 "cfg.tab.c"
    break;

  case 201: /* assign_stm: SERVER_HEADER EQUAL STRING  */
#line 1043 "cfg.y"
                                             { IFOR();
							server_header->s=(yyvsp[0].strval);
							server_header->len=strlen((yyvsp[0].strval));
							}
#line 3817 "cfg.tab.c"
    break;

  case 202: /* assign_stm: SERVER_HEADER EQUAL error  */
#line 1047 "cfg.y"
                                            { yyerror("string value expected"); }
#line 3823 "cfg.tab.c"
    break;

  case 203: /* assign_stm: USER_AGENT_HEADER EQUAL STRING  */
#line 1048 "cfg.y"
                                                 { user_agent_header->s=(yyvsp[0].strval);
			user_agent_header->len=strlen((yyvsp[0].strval));
									}
#line 3831 "cfg.tab.c"
    break;

  case 204: /* assign_stm: USER_AGENT_HEADER EQUAL error  */
#line 1051 "cfg.y"
                                                { yyerror("string value expected"); }
#line 3837 "cfg.tab.c"
    break;

  case 205: /* assign_stm: PV_PRINT_BUF_SIZE EQUAL NUMBER  */
#line 1052 "cfg.y"
                                                 { IFOR();
							pv_print_buf_size = (yyvsp[0].intval); }
#line 3844 "cfg.tab.c"
    break;

  case 206: /* assign_stm: PV_PRINT_BUF_SIZE EQUAL error  */
#line 1054 "cfg.y"
                                                { yyerror("number expected"); }
#line 3850 "cfg.tab.c"
    break;

  case 207: /* assign_stm: XLOG_BUF_SIZE EQUAL NUMBER  */
#line 1055 "cfg.y"
                                             { IFOR();
							xlog_buf_size = (yyvsp[0].intval); }
#line 3857 "cfg.tab.c"
    break;

  case 208: /* assign_stm: XLOG_FORCE_COLOR EQUAL NUMBER  */
#line 1057 "cfg.y"
                                                { IFOR();
							xlog_force_color = (yyvsp[0].intval); }
#line 3864 "cfg.tab.c"
    break;

  case 209: /* assign_stm: XLOG_PRINT_LEVEL EQUAL NUMBER  */
#line 1059 "cfg.y"
                                                { IFOR();
							xlog_print_level = (yyvsp[0].intval); }
#line 3871 "cfg.tab.c"
    break;

  case 210: /* assign_stm: XLOG_BUF_SIZE EQUAL error  */
#line 1061 "cfg.y"
                                            { yyerror("number expected"); }
#line 3877 "cfg.tab.c"
    break;

  case 211: /* assign_stm: XLOG_FORCE_COLOR EQUAL error  */
#line 1062 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3883 "cfg.tab.c"
    break;

  case 212: /* assign_stm: XLOG_PRINT_LEVEL EQUAL error  */
#line 1063 "cfg.y"
                                               { yyerror("number expected"); }
#line 3889 "cfg.tab.c"
    break;

  case 213: /* assign_stm: XLOG_LEVEL EQUAL snumber  */
#line 1064 "cfg.y"
                                           { IFOR();
							*xlog_level = (yyvsp[0].intval); }
#line 3896 "cfg.tab.c"
    break;

  case 214: /* assign_stm: XLOG_LEVEL EQUAL error  */
#line 1066 "cfg.y"
                                         { yyerror("number expected"); }
#line 3902 "cfg.tab.c"
    break;

  case 215: /* assign_stm: SOCKET EQUAL socket_def  */
#line 1067 "cfg.y"
                                          { IFOR();
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listening socket\n");
								break;
							}
						}
#line 3914 "cfg.tab.c"
    break;

  case 216: /* assign_stm: SOCKET EQUAL error  */
#line 1074 "cfg.y"
                                      { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 3922 "cfg.tab.c"
    break;

  case 217: /* assign_stm: LISTEN EQUAL socket_def  */
#line 1077 "cfg.y"
                                          { IFOR();
							warn("'listen' is deprecated, use 'socket' instead");
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listen address\n");
								break;
							}
						}
#line 3935 "cfg.tab.c"
    break;

  case 218: /* assign_stm: LISTEN EQUAL error  */
#line 1085 "cfg.y"
                                      { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 3943 "cfg.tab.c"
    break;

  case 219: /* assign_stm: MEMGROUP EQUAL STRING COLON multi_string  */
#line 1088 "cfg.y"
                                                           { IFOR();
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 3992 "cfg.tab.c"
    break;

  case 220: /* assign_stm: MEMGROUP EQUAL STRING COLON error  */
#line 1132 "cfg.y"
                                                    { yyerror("invalid or no module specified"); }
#line 3998 "cfg.tab.c"
    break;

  case 221: /* assign_stm: ALIAS EQUAL id_lst  */
#line 1133 "cfg.y"
                                      { IFOR();
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 4008 "cfg.tab.c"
    break;

  case 222: /* assign_stm: ALIAS EQUAL error  */
#line 1138 "cfg.y"
                                      { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 4015 "cfg.tab.c"
    break;

  case 223: /* assign_stm: AUTO_ALIASES EQUAL NUMBER  */
#line 1140 "cfg.y"
                                            { IFOR();
								auto_aliases=(yyvsp[0].intval); }
#line 4022 "cfg.tab.c"
    break;

  case 224: /* assign_stm: AUTO_ALIASES EQUAL error  */
#line 1142 "cfg.y"
                                            { yyerror("number  expected"); }
#line 4028 "cfg.tab.c"
    break;

  case 225: /* assign_stm: ADVERTISED_ADDRESS EQUAL listen_id  */
#line 1143 "cfg.y"
                                                     { IFOR();
								if ((yyvsp[0].strval)) {
									default_global_address->s=(yyvsp[0].strval);
									default_global_address->len=strlen((yyvsp[0].strval));
								}
								}
#line 4039 "cfg.tab.c"
    break;

  case 226: /* assign_stm: ADVERTISED_ADDRESS EQUAL error  */
#line 1149 "cfg.y"
                                                 {yyerror("ip address or hostname "
												"expected"); }
#line 4046 "cfg.tab.c"
    break;

  case 227: /* assign_stm: ADVERTISED_PORT EQUAL NUMBER  */
#line 1151 "cfg.y"
                                               { IFOR();
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port->len)
									default_global_port->s =
									pkg_realloc(default_global_port->s, i_tmp);
								if (!default_global_port->s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port->len = i_tmp;
									memcpy(default_global_port->s, tmp,
											default_global_port->len);
								}
								}
#line 4065 "cfg.tab.c"
    break;

  case 228: /* assign_stm: ADVERTISED_PORT EQUAL error  */
#line 1165 "cfg.y"
                                             {yyerror("ip address or hostname "
												"expected"); }
#line 4072 "cfg.tab.c"
    break;

  case 229: /* assign_stm: DISABLE_CORE EQUAL NUMBER  */
#line 1167 "cfg.y"
                                            { IFOR();
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4080 "cfg.tab.c"
    break;

  case 230: /* assign_stm: DISABLE_CORE EQUAL error  */
#line 1170 "cfg.y"
                                           { yyerror("boolean value expected"); }
#line 4086 "cfg.tab.c"
    break;

  case 231: /* assign_stm: OPEN_FD_LIMIT EQUAL NUMBER  */
#line 1171 "cfg.y"
                                             { IFOR();
										open_files_limit=(yyvsp[0].intval);
									}
#line 4094 "cfg.tab.c"
    break;

  case 232: /* assign_stm: OPEN_FD_LIMIT EQUAL error  */
#line 1174 "cfg.y"
                                            { yyerror("number expected"); }
#line 4100 "cfg.tab.c"
    break;

  case 233: /* assign_stm: MCAST_LOOPBACK EQUAL NUMBER  */
#line 1175 "cfg.y"
                                              { IFOR();
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4112 "cfg.tab.c"
    break;

  case 234: /* assign_stm: MCAST_LOOPBACK EQUAL error  */
#line 1182 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 4118 "cfg.tab.c"
    break;

  case 235: /* assign_stm: MCAST_TTL EQUAL NUMBER  */
#line 1183 "cfg.y"
                                         { IFOR();
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4130 "cfg.tab.c"
    break;

  case 236: /* assign_stm: MCAST_TTL EQUAL error  */
#line 1190 "cfg.y"
                                        { yyerror("number expected as tos"); }
#line 4136 "cfg.tab.c"
    break;

  case 237: /* assign_stm: TOS EQUAL NUMBER  */
#line 1191 "cfg.y"
                                   { IFOR(); tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 4145 "cfg.tab.c"
    break;

  case 238: /* assign_stm: TOS EQUAL ID  */
#line 1195 "cfg.y"
                               { IFOR();
							if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 4178 "cfg.tab.c"
    break;

  case 239: /* assign_stm: TOS EQUAL error  */
#line 1223 "cfg.y"
                                  { yyerror("number expected"); }
#line 4184 "cfg.tab.c"
    break;

  case 240: /* assign_stm: MPATH EQUAL STRING  */
#line 1224 "cfg.y"
                                     {IFOR();
				set_mpath((yyvsp[0].strval)); }
#line 4191 "cfg.tab.c"
    break;

  case 241: /* assign_stm: MPATH EQUAL error  */
#line 1226 "cfg.y"
                                     { yyerror("string value expected"); }
#line 4197 "cfg.tab.c"
    break;

  case 242: /* assign_stm: DISABLE_DNS_FAILOVER EQUAL NUMBER  */
#line 1227 "cfg.y"
                                                    { IFOR();
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 4205 "cfg.tab.c"
    break;

  case 243: /* assign_stm: DISABLE_DNS_FAILOVER error  */
#line 1230 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 4211 "cfg.tab.c"
    break;

  case 244: /* assign_stm: DISABLE_DNS_BLACKLIST EQUAL NUMBER  */
#line 1231 "cfg.y"
                                                     { IFOR();
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 4219 "cfg.tab.c"
    break;

  case 245: /* assign_stm: DISABLE_DNS_BLACKLIST error  */
#line 1234 "cfg.y"
                                              { yyerror("boolean value expected"); }
#line 4225 "cfg.tab.c"
    break;

  case 246: /* assign_stm: DST_BLACKLIST EQUAL ID COLON LBRACE blst_elem_list RBRACE  */
#line 1235 "cfg.y"
                                                                            { IFOR();
				s_tmp.s = (yyvsp[-4].strval);
				s_tmp.len = strlen((yyvsp[-4].strval));
				if (create_bl_head( BL_CORE_ID, BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4240 "cfg.tab.c"
    break;

  case 247: /* assign_stm: DISABLE_STATELESS_FWD EQUAL NUMBER  */
#line 1245 "cfg.y"
                                                     { IFOR();
				sl_fwd_disabled=(yyvsp[0].intval); }
#line 4247 "cfg.tab.c"
    break;

  case 248: /* assign_stm: DB_VERSION_TABLE EQUAL STRING  */
#line 1247 "cfg.y"
                                                { IFOR();
				db_version_table=(yyvsp[0].strval); }
#line 4254 "cfg.tab.c"
    break;

  case 249: /* assign_stm: DB_VERSION_TABLE EQUAL error  */
#line 1249 "cfg.y"
                                               { yyerror("string value expected"); }
#line 4260 "cfg.tab.c"
    break;

  case 250: /* assign_stm: DB_DEFAULT_URL EQUAL STRING  */
#line 1250 "cfg.y"
                                              { IFOR();
				db_default_url=(yyvsp[0].strval); }
#line 4267 "cfg.tab.c"
    break;

  case 251: /* assign_stm: DB_DEFAULT_URL EQUAL error  */
#line 1252 "cfg.y"
                                             { yyerror("string value expected"); }
#line 4273 "cfg.tab.c"
    break;

  case 252: /* assign_stm: DB_MAX_ASYNC_CONNECTIONS EQUAL NUMBER  */
#line 1253 "cfg.y"
                                                        { IFOR();
				db_max_async_connections=(yyvsp[0].intval); }
#line 4280 "cfg.tab.c"
    break;

  case 253: /* assign_stm: DB_MAX_ASYNC_CONNECTIONS EQUAL error  */
#line 1255 "cfg.y"
                                                       {
				yyerror("integer value expected");
				}
#line 4288 "cfg.tab.c"
    break;

  case 254: /* assign_stm: DISABLE_503_TRANSLATION EQUAL NUMBER  */
#line 1258 "cfg.y"
                                                       { IFOR();
				disable_503_translation=(yyvsp[0].intval); }
#line 4295 "cfg.tab.c"
    break;

  case 255: /* assign_stm: DISABLE_503_TRANSLATION EQUAL error  */
#line 1260 "cfg.y"
                                                      {
				yyerror("integer value expected");
				}
#line 4303 "cfg.tab.c"
    break;

  case 256: /* assign_stm: AUTO_SCALING_PROFILE EQUAL auto_scale_profile_def  */
#line 1263 "cfg.y"
                                                                    {}
#line 4309 "cfg.tab.c"
    break;

  case 257: /* assign_stm: AUTO_SCALING_PROFILE EQUAL error  */
#line 1264 "cfg.y"
                                                   {
				yyerror("bad auto-scaling profile definition");
				}
#line 4317 "cfg.tab.c"
    break;

  case 258: /* assign_stm: AUTO_SCALING_CYCLE EQUAL NUMBER  */
#line 1267 "cfg.y"
                                                  { IFOR();
				auto_scaling_cycle=(yyvsp[0].intval); }
#line 4324 "cfg.tab.c"
    break;

  case 259: /* assign_stm: AUTO_SCALING_CYCLE EQUAL error  */
#line 1269 "cfg.y"
                                                 {
				yyerror("integer value expected");
				}
#line 4332 "cfg.tab.c"
    break;

  case 260: /* assign_stm: error EQUAL  */
#line 1272 "cfg.y"
                              { yyerror("unknown config variable"); }
#line 4338 "cfg.tab.c"
    break;

  case 261: /* module_stm: LOADMODULE STRING  */
#line 1275 "cfg.y"
                                        { IFOR();
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 4347 "cfg.tab.c"
    break;

  case 262: /* module_stm: LOADMODULE error  */
#line 1279 "cfg.y"
                                        { yyerror("string expected");  }
#line 4353 "cfg.tab.c"
    break;

  case 263: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 1280 "cfg.y"
                                                                          { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4364 "cfg.tab.c"
    break;

  case 264: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA snumber RPAREN  */
#line 1286 "cfg.y"
                                                                           { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4375 "cfg.tab.c"
    break;

  case 265: /* module_stm: MODPARAM error  */
#line 1292 "cfg.y"
                                 { yyerror("Invalid arguments"); }
#line 4381 "cfg.tab.c"
    break;

  case 266: /* ip: ipv4  */
#line 1296 "cfg.y"
                       { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4387 "cfg.tab.c"
    break;

  case 267: /* ip: ipv6  */
#line 1297 "cfg.y"
                       { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4393 "cfg.tab.c"
    break;

  case 268: /* ipv4: IPV4ADDR  */
#line 1300 "cfg.y"
                 {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 4412 "cfg.tab.c"
    break;

  case 269: /* ipv6addr: IPV6ADDR  */
#line 1316 "cfg.y"
                         {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 4431 "cfg.tab.c"
    break;

  case 270: /* ipv6: ipv6addr  */
#line 1332 "cfg.y"
                 { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4437 "cfg.tab.c"
    break;

  case 271: /* ipv6: LBRACK ipv6addr RBRACK  */
#line 1333 "cfg.y"
                                 {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 4443 "cfg.tab.c"
    break;

  case 272: /* ipnet: IPNET  */
#line 1336 "cfg.y"
                {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 4454 "cfg.tab.c"
    break;

  case 273: /* ipnet: ip  */
#line 1342 "cfg.y"
                        {
				(yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8);
				pkg_free((yyvsp[0].ipaddr));
			}
#line 4463 "cfg.tab.c"
    break;

  case 274: /* folded_string: STRING STRING  */
#line 1352 "cfg.y"
                              {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4478 "cfg.tab.c"
    break;

  case 275: /* folded_string: folded_string STRING  */
#line 1362 "cfg.y"
                                       {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4493 "cfg.tab.c"
    break;

  case 276: /* route_name: ID  */
#line 1373 "cfg.y"
                {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 4501 "cfg.tab.c"
    break;

  case 277: /* route_name: NUMBER  */
#line 1376 "cfg.y"
                         {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 4515 "cfg.tab.c"
    break;

  case 278: /* route_name: STRING  */
#line 1385 "cfg.y"
                        {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 4523 "cfg.tab.c"
    break;

  case 279: /* route_name_var: route_name  */
#line 1390 "cfg.y"
                           {
				/* check to see if there are any "$" in the string name */
				tmp = strchr((yyvsp[0].strval), '$');
				if (!tmp) {
					/* route name is a cosntant string - search for the route */
					rn_tmp.data = 0;
					rn_tmp.iname = get_script_route_idx((yyvsp[0].strval), sroutes->request,
							RT_NO, 0);
					if (rn_tmp.iname==-1)
						yyerror("too many script routes");
					(yyval.intval) = NUMBER_ST;
				} else {
					tstr.s = (yyvsp[0].strval);
					tstr.len = strlen(tstr.s);
					if (pv_parse_format(&tstr, &elem) < 0) {
						yyerror("cannot parse format");
						YYABORT;
					}
					/* the route name is a format, so we can't evaluate it now */
					rn_tmp.ename = elem;
					(yyval.intval) = SCRIPTVAR_ELEM_ST;
				}
			}
#line 4551 "cfg.tab.c"
    break;

  case 280: /* route_name_var: script_var  */
#line 1413 "cfg.y"
                             {
				rn_tmp.sname = (yyvsp[0].specval);
				(yyval.intval) = SCRIPTVAR_ST;
		}
#line 4560 "cfg.tab.c"
    break;

  case 281: /* route_stm: ROUTE LBRACE actions RBRACE  */
#line 1418 "cfg.y"
                                        {
						if (sroutes->request[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
					}
#line 4573 "cfg.tab.c"
    break;

  case 282: /* route_stm: ROUTE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1426 "cfg.y"
                                                                       {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (sroutes->request[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx( (yyvsp[-4].strval),
								sroutes->request, RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &sroutes->request[i_tmp].a);
						}
					}
#line 4594 "cfg.tab.c"
    break;

  case 283: /* route_stm: ROUTE error  */
#line 1442 "cfg.y"
                              { yyerror("invalid  route  statement"); }
#line 4600 "cfg.tab.c"
    break;

  case 284: /* failure_route_stm: ROUTE_FAILURE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1445 "cfg.y"
                                                                                {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->failure,
							FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->failure[i_tmp].a);
					}
#line 4611 "cfg.tab.c"
    break;

  case 285: /* failure_route_stm: ROUTE_FAILURE error  */
#line 1451 "cfg.y"
                                      { yyerror("invalid failure_route statement"); }
#line 4617 "cfg.tab.c"
    break;

  case 286: /* onreply_route_stm: ROUTE_ONREPLY LBRACE actions RBRACE  */
#line 1454 "cfg.y"
                                                       {
						if (sroutes->onreply[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->onreply[DEFAULT_RT].a);
					}
#line 4630 "cfg.tab.c"
    break;

  case 287: /* onreply_route_stm: ROUTE_ONREPLY LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1462 "cfg.y"
                                                                               {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->onreply,
							ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->onreply[i_tmp].a);
					}
#line 4641 "cfg.tab.c"
    break;

  case 288: /* onreply_route_stm: ROUTE_ONREPLY error  */
#line 1468 "cfg.y"
                                      { yyerror("invalid onreply_route statement"); }
#line 4647 "cfg.tab.c"
    break;

  case 289: /* branch_route_stm: ROUTE_BRANCH LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1471 "cfg.y"
                                                                              {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->branch,
							BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->branch[i_tmp].a);
					}
#line 4658 "cfg.tab.c"
    break;

  case 290: /* branch_route_stm: ROUTE_BRANCH error  */
#line 1477 "cfg.y"
                                     { yyerror("invalid branch_route statement"); }
#line 4664 "cfg.tab.c"
    break;

  case 291: /* error_route_stm: ROUTE_ERROR LBRACE actions RBRACE  */
#line 1480 "cfg.y"
                                                    {
						if (sroutes->error.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->error.a);
					}
#line 4677 "cfg.tab.c"
    break;

  case 292: /* error_route_stm: ROUTE_ERROR error  */
#line 1488 "cfg.y"
                                    { yyerror("invalid error_route statement"); }
#line 4683 "cfg.tab.c"
    break;

  case 293: /* local_route_stm: ROUTE_LOCAL LBRACE actions RBRACE  */
#line 1491 "cfg.y"
                                                    {
						if (sroutes->local.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->local.a);
					}
#line 4696 "cfg.tab.c"
    break;

  case 294: /* local_route_stm: ROUTE_LOCAL error  */
#line 1499 "cfg.y"
                                    { yyerror("invalid local_route statement"); }
#line 4702 "cfg.tab.c"
    break;

  case 295: /* startup_route_stm: ROUTE_STARTUP LBRACE actions RBRACE  */
#line 1502 "cfg.y"
                                                        {
						if (sroutes->startup.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->startup.a);
					}
#line 4715 "cfg.tab.c"
    break;

  case 296: /* startup_route_stm: ROUTE_STARTUP error  */
#line 1510 "cfg.y"
                                      { yyerror("invalid startup_route statement"); }
#line 4721 "cfg.tab.c"
    break;

  case 297: /* timer_route_stm: ROUTE_TIMER LBRACK route_name COMMA NUMBER RBRACK LBRACE actions RBRACE  */
#line 1513 "cfg.y"
                                                                                          {
						i_tmp = 0;
						while(i_tmp<TIMER_RT_NO && sroutes->timer[i_tmp].a!=0){
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						sroutes->timer[i_tmp].name = (yyvsp[-6].strval);
						sroutes->timer[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &sroutes->timer[i_tmp].a);
					}
#line 4739 "cfg.tab.c"
    break;

  case 298: /* timer_route_stm: ROUTE_TIMER error  */
#line 1526 "cfg.y"
                                    { yyerror("invalid timer_route statement"); }
#line 4745 "cfg.tab.c"
    break;

  case 299: /* event_route_stm: ROUTE_EVENT LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1529 "cfg.y"
                                                                            {
						i_tmp = get_script_route_idx((yyvsp[-4].strval), sroutes->event,
								EVENT_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->event[i_tmp].a);
					}
#line 4756 "cfg.tab.c"
    break;

  case 300: /* event_route_stm: ROUTE_EVENT error  */
#line 1535 "cfg.y"
                                    { yyerror("invalid event_route statement"); }
#line 4762 "cfg.tab.c"
    break;

  case 301: /* exp: exp AND exp  */
#line 1540 "cfg.y"
                        { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4768 "cfg.tab.c"
    break;

  case 302: /* exp: exp OR exp  */
#line 1541 "cfg.y"
                                { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 4774 "cfg.tab.c"
    break;

  case 303: /* exp: NOT exp  */
#line 1542 "cfg.y"
                                        { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 4780 "cfg.tab.c"
    break;

  case 304: /* exp: LPAREN exp RPAREN  */
#line 1543 "cfg.y"
                                { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 4786 "cfg.tab.c"
    break;

  case 305: /* exp: LBRACK assignexp RBRACK  */
#line 1544 "cfg.y"
                                  { (yyval.expr)=(yyvsp[-1].expr); }
#line 4792 "cfg.tab.c"
    break;

  case 306: /* exp: exp_elem  */
#line 1545 "cfg.y"
                                        { (yyval.expr)=(yyvsp[0].expr); }
#line 4798 "cfg.tab.c"
    break;

  case 307: /* equalop: EQUAL_T  */
#line 1548 "cfg.y"
                          {(yyval.intval)=EQUAL_OP; }
#line 4804 "cfg.tab.c"
    break;

  case 308: /* equalop: DIFF  */
#line 1549 "cfg.y"
                                {(yyval.intval)=DIFF_OP; }
#line 4810 "cfg.tab.c"
    break;

  case 309: /* compop: GT  */
#line 1552 "cfg.y"
                {(yyval.intval)=GT_OP; }
#line 4816 "cfg.tab.c"
    break;

  case 310: /* compop: LT  */
#line 1553 "cfg.y"
                        {(yyval.intval)=LT_OP; }
#line 4822 "cfg.tab.c"
    break;

  case 311: /* compop: GTE  */
#line 1554 "cfg.y"
                        {(yyval.intval)=GTE_OP; }
#line 4828 "cfg.tab.c"
    break;

  case 312: /* compop: LTE  */
#line 1555 "cfg.y"
                        {(yyval.intval)=LTE_OP; }
#line 4834 "cfg.tab.c"
    break;

  case 313: /* matchop: MATCH  */
#line 1557 "cfg.y"
                {(yyval.intval)=MATCH_OP; }
#line 4840 "cfg.tab.c"
    break;

  case 314: /* matchop: NOTMATCH  */
#line 1558 "cfg.y"
                                {(yyval.intval)=NOTMATCH_OP; }
#line 4846 "cfg.tab.c"
    break;

  case 315: /* intop: equalop  */
#line 1561 "cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 4852 "cfg.tab.c"
    break;

  case 316: /* intop: compop  */
#line 1562 "cfg.y"
                        {(yyval.intval)=(yyvsp[0].intval); }
#line 4858 "cfg.tab.c"
    break;

  case 317: /* strop: equalop  */
#line 1565 "cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 4864 "cfg.tab.c"
    break;

  case 318: /* strop: compop  */
#line 1566 "cfg.y"
                     {(yyval.intval)=(yyvsp[0].intval); }
#line 4870 "cfg.tab.c"
    break;

  case 319: /* strop: matchop  */
#line 1567 "cfg.y"
                                {(yyval.intval)=(yyvsp[0].intval); }
#line 4876 "cfg.tab.c"
    break;

  case 320: /* script_var: SCRIPTVAR  */
#line 1570 "cfg.y"
                                {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 4897 "cfg.tab.c"
    break;

  case 321: /* script_var: SCRIPTVARERR  */
#line 1586 "cfg.y"
                               {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 4905 "cfg.tab.c"
    break;

  case 322: /* exp_elem: exp_cond  */
#line 1591 "cfg.y"
                                {(yyval.expr)=(yyvsp[0].expr); }
#line 4911 "cfg.tab.c"
    break;

  case 323: /* exp_elem: exp_stm  */
#line 1592 "cfg.y"
                                        {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 4917 "cfg.tab.c"
    break;

  case 324: /* exp_elem: snumber  */
#line 1593 "cfg.y"
                                        {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 4924 "cfg.tab.c"
    break;

  case 325: /* exp_elem: script_var  */
#line 1595 "cfg.y"
                                {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 4932 "cfg.tab.c"
    break;

  case 326: /* exp_cond: script_var strop script_var  */
#line 1600 "cfg.y"
                                      {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 4940 "cfg.tab.c"
    break;

  case 327: /* exp_cond: script_var strop STRING  */
#line 1603 "cfg.y"
                                          {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 4948 "cfg.tab.c"
    break;

  case 328: /* exp_cond: script_var intop snumber  */
#line 1606 "cfg.y"
                                           {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 4956 "cfg.tab.c"
    break;

  case 329: /* exp_cond: script_var equalop NULLV  */
#line 1609 "cfg.y"
                                                {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 4964 "cfg.tab.c"
    break;

  case 330: /* exp_cond: script_var equalop ipnet  */
#line 1612 "cfg.y"
                                           {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 4972 "cfg.tab.c"
    break;

  case 331: /* assignop: EQUAL  */
#line 1618 "cfg.y"
              { (yyval.intval) = EQ_T; }
#line 4978 "cfg.tab.c"
    break;

  case 332: /* assignop: COLONEQ  */
#line 1619 "cfg.y"
                  { (yyval.intval) = COLONEQ_T; }
#line 4984 "cfg.tab.c"
    break;

  case 333: /* assignop: PLUSEQ  */
#line 1620 "cfg.y"
                 { (yyval.intval) = PLUSEQ_T; }
#line 4990 "cfg.tab.c"
    break;

  case 334: /* assignop: MINUSEQ  */
#line 1621 "cfg.y"
                  { (yyval.intval) = MINUSEQ_T;}
#line 4996 "cfg.tab.c"
    break;

  case 335: /* assignop: SLASHEQ  */
#line 1622 "cfg.y"
                  { (yyval.intval) = DIVEQ_T; }
#line 5002 "cfg.tab.c"
    break;

  case 336: /* assignop: MULTEQ  */
#line 1623 "cfg.y"
                 { (yyval.intval) = MULTEQ_T; }
#line 5008 "cfg.tab.c"
    break;

  case 337: /* assignop: MODULOEQ  */
#line 1624 "cfg.y"
                   { (yyval.intval) = MODULOEQ_T; }
#line 5014 "cfg.tab.c"
    break;

  case 338: /* assignop: BANDEQ  */
#line 1625 "cfg.y"
                 { (yyval.intval) = BANDEQ_T; }
#line 5020 "cfg.tab.c"
    break;

  case 339: /* assignop: BOREQ  */
#line 1626 "cfg.y"
                { (yyval.intval) = BOREQ_T; }
#line 5026 "cfg.tab.c"
    break;

  case 340: /* assignop: BXOREQ  */
#line 1627 "cfg.y"
                 { (yyval.intval) = BXOREQ_T; }
#line 5032 "cfg.tab.c"
    break;

  case 341: /* assignexp: snumber  */
#line 1631 "cfg.y"
                { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5038 "cfg.tab.c"
    break;

  case 342: /* assignexp: STRING  */
#line 1632 "cfg.y"
                 { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5044 "cfg.tab.c"
    break;

  case 343: /* assignexp: script_var  */
#line 1633 "cfg.y"
                     { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5050 "cfg.tab.c"
    break;

  case 344: /* assignexp: exp_cond  */
#line 1634 "cfg.y"
                   { (yyval.expr)= (yyvsp[0].expr); }
#line 5056 "cfg.tab.c"
    break;

  case 345: /* assignexp: cmd  */
#line 1635 "cfg.y"
              { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5062 "cfg.tab.c"
    break;

  case 346: /* assignexp: assignexp PLUS assignexp  */
#line 1636 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5070 "cfg.tab.c"
    break;

  case 347: /* assignexp: assignexp MINUS assignexp  */
#line 1639 "cfg.y"
                                    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5078 "cfg.tab.c"
    break;

  case 348: /* assignexp: assignexp MULT assignexp  */
#line 1642 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5086 "cfg.tab.c"
    break;

  case 349: /* assignexp: assignexp SLASH assignexp  */
#line 1645 "cfg.y"
                                    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5094 "cfg.tab.c"
    break;

  case 350: /* assignexp: assignexp MODULO assignexp  */
#line 1648 "cfg.y"
                                     {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5102 "cfg.tab.c"
    break;

  case 351: /* assignexp: assignexp BAND assignexp  */
#line 1651 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5110 "cfg.tab.c"
    break;

  case 352: /* assignexp: assignexp BOR assignexp  */
#line 1654 "cfg.y"
                                  {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5118 "cfg.tab.c"
    break;

  case 353: /* assignexp: assignexp BXOR assignexp  */
#line 1657 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5126 "cfg.tab.c"
    break;

  case 354: /* assignexp: assignexp BLSHIFT assignexp  */
#line 1660 "cfg.y"
                                      {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5134 "cfg.tab.c"
    break;

  case 355: /* assignexp: assignexp BRSHIFT assignexp  */
#line 1663 "cfg.y"
                                      {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5142 "cfg.tab.c"
    break;

  case 356: /* assignexp: BNOT assignexp  */
#line 1666 "cfg.y"
                         {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5150 "cfg.tab.c"
    break;

  case 357: /* assignexp: LPAREN assignexp RPAREN  */
#line 1669 "cfg.y"
                                  { (yyval.expr) = (yyvsp[-1].expr); }
#line 5156 "cfg.tab.c"
    break;

  case 358: /* assign_cmd: script_var assignop assignexp  */
#line 1672 "cfg.y"
                                          {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5174 "cfg.tab.c"
    break;

  case 359: /* assign_cmd: script_var EQUAL NULLV  */
#line 1685 "cfg.y"
                                  {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5192 "cfg.tab.c"
    break;

  case 360: /* assign_cmd: script_var COLONEQ NULLV  */
#line 1698 "cfg.y"
                                    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5210 "cfg.tab.c"
    break;

  case 361: /* exp_stm: cmd  */
#line 1713 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5216 "cfg.tab.c"
    break;

  case 362: /* exp_stm: if_cmd  */
#line 1714 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5222 "cfg.tab.c"
    break;

  case 363: /* exp_stm: assign_cmd  */
#line 1715 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5228 "cfg.tab.c"
    break;

  case 364: /* exp_stm: LBRACE actions RBRACE  */
#line 1716 "cfg.y"
                                                { (yyval.action)=(yyvsp[-1].action); }
#line 5234 "cfg.tab.c"
    break;

  case 365: /* exp_stm: LBRACE RBRACE  */
#line 1717 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5240 "cfg.tab.c"
    break;

  case 366: /* brk_stm: brk_action  */
#line 1720 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5246 "cfg.tab.c"
    break;

  case 367: /* brk_stm: LBRACE brk_actions RBRACE  */
#line 1721 "cfg.y"
                                                        { (yyval.action)=(yyvsp[-1].action); }
#line 5252 "cfg.tab.c"
    break;

  case 368: /* brk_stm: LBRACE RBRACE  */
#line 1722 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5258 "cfg.tab.c"
    break;

  case 369: /* stm: action  */
#line 1725 "cfg.y"
                                                        { (yyval.action)=(yyvsp[0].action); }
#line 5264 "cfg.tab.c"
    break;

  case 370: /* stm: LBRACE actions RBRACE  */
#line 1726 "cfg.y"
                                                { (yyval.action)=(yyvsp[-1].action); }
#line 5270 "cfg.tab.c"
    break;

  case 371: /* stm: LBRACE RBRACE  */
#line 1727 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5276 "cfg.tab.c"
    break;

  case 372: /* actions: actions action  */
#line 1730 "cfg.y"
                                {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5282 "cfg.tab.c"
    break;

  case 373: /* actions: action  */
#line 1731 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5288 "cfg.tab.c"
    break;

  case 374: /* actions: actions error  */
#line 1732 "cfg.y"
                                { (yyval.action)=0; yyerror("bad command!)"); }
#line 5294 "cfg.tab.c"
    break;

  case 375: /* brk_actions: brk_actions brk_action  */
#line 1736 "cfg.y"
                                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5300 "cfg.tab.c"
    break;

  case 376: /* brk_actions: brk_action  */
#line 1737 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5306 "cfg.tab.c"
    break;

  case 377: /* brk_actions: brk_actions error  */
#line 1738 "cfg.y"
                                    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5312 "cfg.tab.c"
    break;

  case 378: /* action: cmd SEMICOLON  */
#line 1741 "cfg.y"
                              {(yyval.action)=(yyvsp[-1].action);}
#line 5318 "cfg.tab.c"
    break;

  case 379: /* action: if_cmd  */
#line 1742 "cfg.y"
                         {(yyval.action)=(yyvsp[0].action);}
#line 5324 "cfg.tab.c"
    break;

  case 380: /* action: while_cmd  */
#line 1743 "cfg.y"
                            {(yyval.action)=(yyvsp[0].action);}
#line 5330 "cfg.tab.c"
    break;

  case 381: /* action: foreach_cmd  */
#line 1744 "cfg.y"
                              {(yyval.action)=(yyvsp[0].action);}
#line 5336 "cfg.tab.c"
    break;

  case 382: /* action: switch_cmd  */
#line 1745 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5342 "cfg.tab.c"
    break;

  case 383: /* action: assign_cmd SEMICOLON  */
#line 1746 "cfg.y"
                                       {(yyval.action)=(yyvsp[-1].action);}
#line 5348 "cfg.tab.c"
    break;

  case 384: /* action: SEMICOLON  */
#line 1747 "cfg.y"
                                              {(yyval.action)=0;}
#line 5354 "cfg.tab.c"
    break;

  case 385: /* action: cmd error  */
#line 1748 "cfg.y"
                            { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5360 "cfg.tab.c"
    break;

  case 386: /* brk_action: BREAK SEMICOLON  */
#line 1751 "cfg.y"
                            { mk_action0((yyval.action), BREAK_T);}
#line 5366 "cfg.tab.c"
    break;

  case 387: /* brk_action: cmd SEMICOLON  */
#line 1752 "cfg.y"
                                {(yyval.action)=(yyvsp[-1].action);}
#line 5372 "cfg.tab.c"
    break;

  case 388: /* brk_action: brk_if_cmd  */
#line 1753 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5378 "cfg.tab.c"
    break;

  case 389: /* brk_action: while_cmd  */
#line 1754 "cfg.y"
                            {(yyval.action)=(yyvsp[0].action);}
#line 5384 "cfg.tab.c"
    break;

  case 390: /* brk_action: foreach_cmd  */
#line 1755 "cfg.y"
                              {(yyval.action)=(yyvsp[0].action);}
#line 5390 "cfg.tab.c"
    break;

  case 391: /* brk_action: switch_cmd  */
#line 1756 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5396 "cfg.tab.c"
    break;

  case 392: /* brk_action: assign_cmd SEMICOLON  */
#line 1757 "cfg.y"
                                       {(yyval.action)=(yyvsp[-1].action);}
#line 5402 "cfg.tab.c"
    break;

  case 393: /* brk_action: SEMICOLON  */
#line 1758 "cfg.y"
                                              {(yyval.action)=0;}
#line 5408 "cfg.tab.c"
    break;

  case 394: /* brk_action: cmd error  */
#line 1759 "cfg.y"
                            { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5414 "cfg.tab.c"
    break;

  case 395: /* brk_if_cmd: IF LPAREN exp RPAREN brk_stm  */
#line 1762 "cfg.y"
                                                                { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5427 "cfg.tab.c"
    break;

  case 396: /* brk_if_cmd: IF LPAREN exp RPAREN brk_stm ELSE brk_stm  */
#line 1770 "cfg.y"
                                                                        { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5440 "cfg.tab.c"
    break;

  case 397: /* if_cmd: IF LPAREN exp RPAREN stm  */
#line 1780 "cfg.y"
                                                                        { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5453 "cfg.tab.c"
    break;

  case 398: /* if_cmd: IF LPAREN exp RPAREN stm ELSE stm  */
#line 1788 "cfg.y"
                                                                { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5466 "cfg.tab.c"
    break;

  case 399: /* while_cmd: WHILE LPAREN exp RPAREN brk_stm  */
#line 1798 "cfg.y"
                                                        { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action));
									}
#line 5477 "cfg.tab.c"
    break;

  case 400: /* foreach_cmd: FOR LPAREN script_var IN script_var RPAREN brk_stm  */
#line 1806 "cfg.y"
                                                                   {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 5498 "cfg.tab.c"
    break;

  case 401: /* switch_cmd: SWITCH LPAREN script_var RPAREN LBRACE switch_stm RBRACE  */
#line 1824 "cfg.y"
                                                                                        {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 5510 "cfg.tab.c"
    break;

  case 402: /* switch_stm: case_stms default_stm  */
#line 1833 "cfg.y"
                                  { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5516 "cfg.tab.c"
    break;

  case 403: /* switch_stm: case_stms  */
#line 1834 "cfg.y"
                                                { (yyval.action)=(yyvsp[0].action); }
#line 5522 "cfg.tab.c"
    break;

  case 404: /* case_stms: case_stms case_stm  */
#line 1836 "cfg.y"
                                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5528 "cfg.tab.c"
    break;

  case 405: /* case_stms: case_stm  */
#line 1837 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5534 "cfg.tab.c"
    break;

  case 406: /* case_stm: CASE snumber COLON brk_actions  */
#line 1840 "cfg.y"
                                         { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action));
											}
#line 5545 "cfg.tab.c"
    break;

  case 407: /* case_stm: CASE snumber COLON  */
#line 1846 "cfg.y"
                                     { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].intval),
													NULL);
							}
#line 5556 "cfg.tab.c"
    break;

  case 408: /* case_stm: CASE STRING COLON brk_actions  */
#line 1852 "cfg.y"
                                                { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action));
											}
#line 5567 "cfg.tab.c"
    break;

  case 409: /* case_stm: CASE STRING COLON  */
#line 1858 "cfg.y"
                                    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].strval),
													NULL);
							}
#line 5578 "cfg.tab.c"
    break;

  case 410: /* default_stm: DEFAULT COLON brk_actions  */
#line 1866 "cfg.y"
                                       { mk_action1( (yyval.action), DEFAULT_T,
													ACTIONS_ST, (yyvsp[0].action));
									}
#line 5586 "cfg.tab.c"
    break;

  case 411: /* default_stm: DEFAULT COLON  */
#line 1869 "cfg.y"
                                { mk_action1( (yyval.action), DEFAULT_T, ACTIONS_ST, NULL); }
#line 5592 "cfg.tab.c"
    break;

  case 412: /* func_param: STRING  */
#line 1872 "cfg.y"
                   {
										elems[1].type = STR_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 5602 "cfg.tab.c"
    break;

  case 413: /* func_param: func_param COMMA STRING  */
#line 1877 "cfg.y"
                                          {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5617 "cfg.tab.c"
    break;

  case 414: /* func_param: COMMA  */
#line 1887 "cfg.y"
                        {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 5629 "cfg.tab.c"
    break;

  case 415: /* func_param: COMMA STRING  */
#line 1894 "cfg.y"
                               {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STR_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 5641 "cfg.tab.c"
    break;

  case 416: /* func_param: func_param COMMA  */
#line 1901 "cfg.y"
                                   {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 5656 "cfg.tab.c"
    break;

  case 417: /* func_param: snumber  */
#line 1911 "cfg.y"
                          {
										elems[1].type = NUMBER_ST;
										elems[1].u.number = (yyvsp[0].intval);
										(yyval.intval)=1;
										}
#line 5666 "cfg.tab.c"
    break;

  case 418: /* func_param: COMMA snumber  */
#line 1916 "cfg.y"
                                {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NUMBER_ST;
										elems[2].u.number = (yyvsp[0].intval);
										(yyval.intval)=2;
										}
#line 5678 "cfg.tab.c"
    break;

  case 419: /* func_param: func_param COMMA snumber  */
#line 1923 "cfg.y"
                                           {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = NUMBER_ST;
										elems[(yyvsp[-2].intval)+1].u.number = (yyvsp[0].intval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5693 "cfg.tab.c"
    break;

  case 420: /* func_param: script_var  */
#line 1933 "cfg.y"
                             {
										elems[1].type = SCRIPTVAR_ST;
										elems[1].u.data = (yyvsp[0].specval);
										(yyval.intval)=1;
										}
#line 5703 "cfg.tab.c"
    break;

  case 421: /* func_param: COMMA script_var  */
#line 1938 "cfg.y"
                                   {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = SCRIPTVAR_ST;
										elems[2].u.data = (yyvsp[0].specval);
										(yyval.intval)=2;
										}
#line 5715 "cfg.tab.c"
    break;

  case 422: /* func_param: func_param COMMA script_var  */
#line 1945 "cfg.y"
                                              {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = SCRIPTVAR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].specval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5730 "cfg.tab.c"
    break;

  case 423: /* route_param: STRING  */
#line 1957 "cfg.y"
                    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.string = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 5740 "cfg.tab.c"
    break;

  case 424: /* route_param: snumber  */
#line 1962 "cfg.y"
                          {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.number = (long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 5750 "cfg.tab.c"
    break;

  case 425: /* route_param: NULLV  */
#line 1967 "cfg.y"
                        {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 5760 "cfg.tab.c"
    break;

  case 426: /* route_param: script_var  */
#line 1972 "cfg.y"
                             {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 5770 "cfg.tab.c"
    break;

  case 427: /* route_param: route_param COMMA STRING  */
#line 1977 "cfg.y"
                                           {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5785 "cfg.tab.c"
    break;

  case 428: /* route_param: route_param COMMA snumber  */
#line 1987 "cfg.y"
                                            {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5800 "cfg.tab.c"
    break;

  case 429: /* route_param: route_param COMMA script_var  */
#line 1997 "cfg.y"
                                               {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5815 "cfg.tab.c"
    break;

  case 430: /* route_param: route_param COMMA NULLV  */
#line 2007 "cfg.y"
                                          {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5830 "cfg.tab.c"
    break;

  case 431: /* async_func: ID LPAREN RPAREN  */
#line 2019 "cfg.y"
                             {
				cmd_tmp=(void*)find_mod_acmd_export_t((yyvsp[-2].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					if (check_acmd_call_params(cmd_tmp,elems,0)<0) {
						yyerrorf("too few parameters "
							"for command <%s>\n", (yyvsp[-2].strval));
						(yyval.action)=0;
					} else {
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, 1, elems);
					}
				}
			}
#line 5853 "cfg.tab.c"
    break;

  case 432: /* async_func: ID LPAREN func_param RPAREN  */
#line 2037 "cfg.y"
                                                      {
				cmd_tmp=(void*)find_mod_acmd_export_t((yyvsp[-3].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					rc = check_acmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
					switch (rc) {
					case -1:
						yyerrorf("too few parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -2:
						yyerrorf("too many parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -3:
						yyerrorf("mandatory parameter "
							" omitted for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					default:
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
					}
				}
			}
#line 5889 "cfg.tab.c"
    break;

  case 433: /* async_func: ID LPAREN error RPAREN  */
#line 2068 "cfg.y"
                                                 {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 5898 "cfg.tab.c"
    break;

  case 434: /* async_func: ID error  */
#line 2072 "cfg.y"
                                   {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 5907 "cfg.tab.c"
    break;

  case 435: /* cmd: ASSERT LPAREN exp COMMA STRING RPAREN  */
#line 2078 "cfg.y"
                                                 {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 5915 "cfg.tab.c"
    break;

  case 436: /* cmd: DROP  */
#line 2081 "cfg.y"
                                                 {mk_action0( (yyval.action), DROP_T); }
#line 5921 "cfg.tab.c"
    break;

  case 437: /* cmd: DROP LPAREN RPAREN  */
#line 2082 "cfg.y"
                                     {mk_action0( (yyval.action), DROP_T); }
#line 5927 "cfg.tab.c"
    break;

  case 438: /* cmd: EXIT  */
#line 2083 "cfg.y"
                                                 {mk_action0( (yyval.action), EXIT_T); }
#line 5933 "cfg.tab.c"
    break;

  case 439: /* cmd: EXIT LPAREN RPAREN  */
#line 2084 "cfg.y"
                                     {mk_action0( (yyval.action), EXIT_T); }
#line 5939 "cfg.tab.c"
    break;

  case 440: /* cmd: RETURN script_var  */
#line 2086 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[0].specval)); }
#line 5945 "cfg.tab.c"
    break;

  case 441: /* cmd: RETURN LPAREN script_var RPAREN  */
#line 2088 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[-1].specval)); }
#line 5951 "cfg.tab.c"
    break;

  case 442: /* cmd: RETURN snumber  */
#line 2090 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[0].intval)); }
#line 5957 "cfg.tab.c"
    break;

  case 443: /* cmd: RETURN LPAREN snumber RPAREN  */
#line 2092 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[-1].intval)); }
#line 5963 "cfg.tab.c"
    break;

  case 444: /* cmd: RETURN LPAREN RPAREN  */
#line 2094 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 5969 "cfg.tab.c"
    break;

  case 445: /* cmd: RETURN  */
#line 2095 "cfg.y"
                                                 {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 5975 "cfg.tab.c"
    break;

  case 446: /* cmd: LOG_TOK LPAREN STRING RPAREN  */
#line 2096 "cfg.y"
                                                {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 5983 "cfg.tab.c"
    break;

  case 447: /* cmd: LOG_TOK LPAREN snumber COMMA STRING RPAREN  */
#line 2099 "cfg.y"
                                                                {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 5994 "cfg.tab.c"
    break;

  case 448: /* cmd: LOG_TOK error  */
#line 2105 "cfg.y"
                                { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6000 "cfg.tab.c"
    break;

  case 449: /* cmd: LOG_TOK LPAREN error RPAREN  */
#line 2106 "cfg.y"
                                              { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 6007 "cfg.tab.c"
    break;

  case 450: /* cmd: ERROR LPAREN STRING COMMA STRING RPAREN  */
#line 2108 "cfg.y"
                                                          {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 6018 "cfg.tab.c"
    break;

  case 451: /* cmd: ERROR error  */
#line 2114 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6024 "cfg.tab.c"
    break;

  case 452: /* cmd: ERROR LPAREN error RPAREN  */
#line 2115 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 6031 "cfg.tab.c"
    break;

  case 453: /* cmd: ROUTE LPAREN route_name_var RPAREN  */
#line 2117 "cfg.y"
                                                        {
						mk_action2( (yyval.action), ROUTE_T, (yyvsp[-1].intval), 0, rn_tmp.data, 0);
					}
#line 6039 "cfg.tab.c"
    break;

  case 454: /* cmd: ROUTE LPAREN route_name_var COMMA route_param RPAREN  */
#line 2121 "cfg.y"
                                                                        {
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, (yyvsp[-3].intval),	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ST,				/* parameters */
							rn_tmp.data,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 6062 "cfg.tab.c"
    break;

  case 455: /* cmd: ROUTE error  */
#line 2140 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6068 "cfg.tab.c"
    break;

  case 456: /* cmd: ROUTE LPAREN error RPAREN  */
#line 2141 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 6075 "cfg.tab.c"
    break;

  case 457: /* cmd: ID LPAREN RPAREN  */
#line 2143 "cfg.y"
                                        {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-2].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-2].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-2].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-2].strval));
									}
									(yyval.action)=0;
								}else{
									if (check_cmd_call_params(cmd_tmp,elems,0)<0) {
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-2].strval));
										(yyval.action)=0;
									} else {
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), CMD_T, 1, elems);
									}
								}
							}
#line 6103 "cfg.tab.c"
    break;

  case 458: /* cmd: ID LPAREN func_param RPAREN  */
#line 2166 "cfg.y"
                                                {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-3].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-3].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-3].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-3].strval));
									}
									(yyval.action)=0;
								}else{
									rc = check_cmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
									switch (rc) {
									case -1:
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -2:
										yyerrorf("too many parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -3:
										yyerrorf("mandatory parameter "
											"omitted for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									default:
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), CMD_T, (yyvsp[-1].intval)+1, elems);
									}
								}
							}
#line 6144 "cfg.tab.c"
    break;

  case 459: /* cmd: ID LPAREN error RPAREN  */
#line 2202 "cfg.y"
                                         { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 6151 "cfg.tab.c"
    break;

  case 460: /* cmd: ID error  */
#line 2204 "cfg.y"
                           { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6159 "cfg.tab.c"
    break;

  case 461: /* cmd: XDBG LPAREN STRING RPAREN  */
#line 2207 "cfg.y"
                                            {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6166 "cfg.tab.c"
    break;

  case 462: /* cmd: XDBG LPAREN folded_string RPAREN  */
#line 2209 "cfg.y"
                                                   {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6173 "cfg.tab.c"
    break;

  case 463: /* cmd: XLOG LPAREN STRING RPAREN  */
#line 2211 "cfg.y"
                                            {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6180 "cfg.tab.c"
    break;

  case 464: /* cmd: XLOG LPAREN folded_string RPAREN  */
#line 2213 "cfg.y"
                                                   {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6187 "cfg.tab.c"
    break;

  case 465: /* cmd: XLOG LPAREN STRING COMMA STRING RPAREN  */
#line 2215 "cfg.y"
                                                         {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6194 "cfg.tab.c"
    break;

  case 466: /* cmd: XLOG LPAREN STRING COMMA folded_string RPAREN  */
#line 2217 "cfg.y"
                                                                {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6201 "cfg.tab.c"
    break;

  case 467: /* cmd: ASYNC_TOKEN LPAREN async_func COMMA route_name RPAREN  */
#line 2219 "cfg.y"
                                                                        {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 6212 "cfg.tab.c"
    break;

  case 468: /* cmd: ASYNC_TOKEN LPAREN async_func COMMA route_name COMMA NUMBER RPAREN  */
#line 2225 "cfg.y"
                                                                                     {
				i_tmp = get_script_route_idx( (yyvsp[-3].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action3((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST, NUMBER_ST,
						(yyvsp[-5].action), (void*)(long)i_tmp, (void*)(long)(yyvsp[-1].intval));
				}
#line 6223 "cfg.tab.c"
    break;

  case 469: /* cmd: LAUNCH_TOKEN LPAREN async_func COMMA route_name RPAREN  */
#line 2231 "cfg.y"
                                                                         {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 6234 "cfg.tab.c"
    break;

  case 470: /* cmd: LAUNCH_TOKEN LPAREN async_func RPAREN  */
#line 2237 "cfg.y"
                                                        {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-1].action), (void*)(long)-1);
				}
#line 6243 "cfg.tab.c"
    break;


#line 6247 "cfg.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2244 "cfg.y"


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	cfg_dump_backtrace();
	LM_CRIT("parse error in %s:%d:%d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	_cfg_dump_context(get_cfg_file_name, line, startcolumn, column, 1);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		memset(l, 0, sizeof(*l));
		l->name     = host;
		l->proto    = proto;
		l->port     = port;
	}

	return l;
}

static void fill_socket_id(struct listen_param *param, struct socket_id *s)
{
	s->flags |= param->flags;
	s->workers = param->workers;
	s->auto_scaling_profile = param->auto_scaling_profile;
	if (param->socket)
		set_listen_id_adv(s, param->socket->name, param->socket->port);
	s->tag = param->tag;
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
